
***[ EB4BGR Public Domain Functions ]*********************

*
* Actualizacin:  15-Sep-2006
*

*
* FUNCIONES DE DOMINIO PBLICO PARA C3 COMPILER 2.0:
*
* La librera EB4BGRC3.PRG es un conjunto de funciones
* y pseudo-funciones de dominio pblico para toda la
* Comunidad xBase.
*
* La mayora de estas funciones fueron desarrolladas en
* el ao 1997, bajo Clipper, aunque he decidido indicar
* como fecha de stas el da en que las convert a C3,
* ya que algunas de ellas las he modificado y ampliado.
*
* El resto de funciones que convierta o desarrolle en el
* futuro, las incluir si lo considero adecuado.
*
*
*
* INFORMACIN TCNICA:
*
* Para compilar estas funciones en su proyecto, tiene
* que establecer el nivel de avisos del compilador C3
* en cero, o insertar al principio del cdigo de su
* proyecto las declaraciones MemVar que correspondan
* para cada una de las variables empleadas en cada
* funcin.
*
* Para usar las funciones de esta librera, tiene que
* inclur la siguiente instruccin al principio del
* cdigo fuente de su proyecto:
*
* #Include "eb4bgrc3.prg"
*
*
*
* COMPATIBILIDAD:
*
* - Clipper 5.xx:
*   Todas las funciones includas que no hagan uso de
*   otras funciones que slamente tenga C3, pueden
*   usarse en Clipper reduciendo, si es necesario,
*   los nombres de las funciones y sus variables a
*   una longitud de 10 caracteres.
*
* - dBase 4.0/5.0:
*   Adems de las indicaciones para Clipper 5.xx,
*   dBase no acepta el caracter ASCII-95 ("_") en los
*   nombres de variables y funciones si se usa como
*   primer caracter identificativo.
*
*
*
* INFORMACIN LEGAL:
*
* El cdigo fuente de esta librera se suministra
* "como est".  El autor no se hace responsable, en
* ningn caso, del funcionamiento, uso, o cualquier
* hecho que se produzca como consecuencia, directa o
* indirectamente, de la utilizacin o modificacin de
* esta librera o sus funciones.
*
* El usuario puede distribur o modificar el cdigo
* fuente de esta librera segn las siguientes
* indicaciones:
*
* 1) El archivo que contiene el cdigo fuente de
*    esta librera, EB4BGRC3.PRG, y todos los archivos
*    que se incluyan en el archivo comprimido, siempre
*    se facilitarn sin modificacin alguna y de forma
*    completamente gratuta para el usuario.  Se
*    permite distriburlo en formato comprimido (RAR,
*    ZIP o cualquier otro, siempre que el archivo no
*    est protegido por contrasea).
*
* 2) El usuario puede inclur en su proyecto todas o
*    cada una de las funciones que necesite, juntas o
*    por separado, sin modificar cualquier lnea de
*    cdigo o texto que contenga cada funcin.  En caso
*    de ser necesario modificar una funcin, el usuario
*    incluir un comentario en el cdigo fuente
*    modificado de cada funcin includa en su proyecto
*    que haga referencia a esta librera de funciones.
*    En cualquiera de estos casos, deber facilitar el
*    cdigo fuente de esta librera, segn lo indicado
*    en el Apartado 1.
*
* 3) En caso de facilitarse algn archivo en formatos
*    <.Obj> o <.Exe>, el autor no permite que se realice
*    ningn tipo de ingeniera inversa o descompilacin
*    sobre estos archivos.
*
* 4) Se prohibe el uso de este software a cualquier persona
*    o entidad para tratar cualquier tipo de informacin que
*    pueda daar, directa o indirectamente, la buena salud
*    fsica, psquica o moral de una o varias personas en
*    cualquier mbito, ya sea nacional o internacional.  Se
*    entiende por buena salud fsica, psquica o moral el
*    mejor estado de salud que pueda tener una persona de
*    forma natural en un entorno de vida completamente sano,
*    libre de coaccin alguna y sin que ello suponga
*    aceptar ninguna caracterstica de su religin o
*    ideologa.
*
* 5) El usuario es el nico responsable de cualquier
*    hecho que realize como consecuencia de la descarga
*    de este archivo, y acepta cualquier responsabilidad
*    que estos hechos puedan ocasionarle.  La descarga o
*    posesin de este archivo o cualquiera de sus partes
*    significa la aceptacin de todas las condiciones
*    indicadas en l por el autor.  En caso de no
*    aceptar cualquiera de las condiciones aqu indicadas
*    debern destruirse todos los archivos includos en
*    esta versin, y las partes correspondientes de esta
*    librera que se incluyan en cualquier archivo o medio
*    de almacenamiento, electrnico o no, donde hayan sido
*    almacenadas.
*
*
*
* FORMA DE CONTACTO:
*
* Si desea ponerse en contacto con el autor de estas
* funciones o hacer una donacin econmica, puede hacerlo
* enviando un correo electrnico a la direccin
* [eb4bgr@yahoo.es].
*

**********************************************************

*
* Areas de Funciones:
*
* - StartUp => Inicio del Entorno de la Librera.
*    StartC3():  Inicio del Entorno para C3.  Es necesario iniciar
*                 esta funcin antes de ejecutar otras funciones de
*                 la librera [EB4BGRC3.PRG].
*
* - Cryptography => Cifrado/DesCifrado de Datos.
*    PsaCryptMd00():  Compatibilidad con Cifrado PSA, Mdulo #00.  No Cifra.
*    PsaCryptMd01():  Compatibilidad con Cifrado PSA, Mdulo #01.  No Cifra.
*    PsaDeCryptMd00():  Compatibilidad con DesCifrado PSA, Mdulo #00.  No DesCifra.
*    PsaDeCryptMd01():  Compatibilidad con DesCifrado PSA, Mdulo #01.  No DesCifra.
*
* - Date => Funciones de Fecha.
*    XDate():  Conversiones Date/String y String/Date.
*
* - FileIO => Funciones de Archivos.
*    FLnGetPos():  Posicin del Puntero en un archivo.
*    FLnGoBottom():  Desplaza Puntero al final del archivo.
*    FLnGoTop():  Desplaza Puntero al principio del archivo.
*    FReadLn():  Obtiene una lnea de un archivo de texto.
*    FSkipLn():  Se desplaza <#> lneas hacia abajo en un archivo de texto.
*    FWriteLn():  Escribe una lnea de caracteres en un archivo de texto.
*
* - Math => Funciones Numricas.
*    CToN():  Conversin de Nmeros en Base-X a Decimal.
*    GetValidRange():  Evala si un nmero est entre dos valores.
*    NToC():  Conversin de Nmeros en Base Decimal a Base-X.
*
* - Memory => Funciones con Dependencia de la Memoria RAM Disponible.
*    ArraySize():  Configura o Devuelve el Valor de [__MaxArraySize] en MBytes o KBytes.
*
* - String => Funciones de Caracteres.
*    AddString():  Relleno de Cadenas de Caracteres en la longitud indicada.
*    CRLF():  Genera tantos CR+LF como se indiquen.
*    ReverseStr():  Devuelve una Cadena de Caracteres en orden inverso.
*    SpcString():  Devuelve Cadenas de Caracteres en la longitud indicada.
*    Str2Bin():  Convierte la cadena de entrada a su equivalente en binario.
*    Str2Dec():  Convierte la cadena de entrada a su equivalente en decimal.
*    StrToArray():  Extrae las lneas de texto de una cadena de caracteres en una matriz.
*    XAt():  Bsqueda de Caracteres desde el principio en datos de tipo String.
*    XGenStr():  Generador de Cadenas de Caracteres (hasta 256 Bytes) y Ejecutor de Comandos xBase.
*    XRAt():  Bsqueda de Caracteres desde el final en datos de tipo String.
*    XSchCnv() - Conversin de Caracteres para bsquedas extendidas.
*
* {Commands}
*    ExecuteCmd():  Ejecutor de Comandos xBase.
*    _C_RunPrint():  Comandos Run & Print.
*    _C_Public():  Declara variables o matrices pblicas.
*

**********************************************************

*()> {StartUp}
Function StartC3()
* StartC3() - Entorno de Inicio de la Librera.
* Desarrollo de la Funcin:  05-Ago-2004 > 30-Nov-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - ArraySize()
* - XDate()
*
* __LibStartDate    - Fecha de Inicio del Entorno de la Librera.
* __LibStartDateStr - Fecha de Inicio del Entorno de la Librera en Formato XDate().
* __LibStartTime    - Hora del Inicio del Entorno de la Librera.
* __MaxArraySize    - Mximo nmero de elementos que se pueden almacenar en un array.
* __MaxCurrency     - Mximo nmero de tipo Currency en 16-Bits.
* __MaxInteger      - Mximo nmero de tipo Integer para clculos matemticos.
* __MinInteger      - Mnimo nmero de tipo Integer para clculos matemticos.
* __MaxInt16        - Mximo nmero de tipo Integer en 16-Bits.
* __MinInt16        - Mnimo nmero de tipo Integer en 16-Bits.
*

 Public __LibStartDate
 Public __LibStartDateStr
 Public __LibStartTime
 Public __MaxArraySize
 Public __MaxCurrency
 Public __MaxInteger
 Public __MinInteger
 Public __MaxInt16
 Public __MinInt16

 Close All
 Set Date Italian
 Set Decimals To 21
 Set Deleted On
 Set Epoch To 2000
 Set Exact On
 Set Fixed On

 __LibStartDate := IIf((Empty(__LibStartDate) <> .F.), Date(), __LibStartDate)
 __LibStartDateStr := IIf((Empty(__LibStartDateStr) <> .F.), XDate(Date(), .T., .T., .F.), __LibStartDateStr)
 __LibStartTime := IIf((Empty(__LibStartTime) <> .F.), Time(), __LibStartTime)
 __MaxArraySize := (1048576)
 __MaxCurrency := (922337203685477.5807)
 __MaxInteger := (8999999999999999)
 __MinInteger := (-8999999999999999)
 __MaxInt16 := (2147483647)
 __MinInt16 := (-2147483647)
 Return (Nil)

**********************************************************

*()> {Cryptography}
Function PsaCryptMd00 (__cIn, __cKey)
* PsaCryptMd00() - Compatibilidad con Cifrado PSA, Mdulo #00.  No Cifra.
* Desarrollo de la Funcin:  25-Feb-2003 > 09-Mar-2003
* (c) Alejandro Padrino, 2.003
*

 Return (__cIn)

*()> {Cryptography}
Function PsaDeCryptMd00 (__cIn, __cKey)
* PsaDeCryptMd00() - Compatibilidad con DesCifrado PSA, Mdulo #00.  No DesCifra.
* Desarrollo de la Funcin:  25-Feb-2003 > 09-Mar-2003
* (c) Alejandro Padrino, 2.003
*

 Return (__cIn)

*()> {Cryptography}
Function PsaCryptMd01 (__cIn, __cKey)
* PsaCryptMd01() - Compatibilidad con Cifrado PSA, Mdulo #01.  No Cifra.
* Desarrollo de la Funcin:  28-Nov-2004 > 30-Nov-2004
* (c) Alejandro Padrino, 2.004
*

 Return (__cIn)

*()> {Cryptography}
Function PsaDeCryptMd01 (__cIn, __cKey)
* PsaDeCryptMd01() - Compatibilidad con DesCifrado PSA, Mdulo #01.  No DesCifra.
* Desarrollo de la Funcin:  28-Nov-2004 > 30-Nov-2004
* (c) Alejandro Padrino, 2.004
*

 Return (__cIn)

**********************************************************

*()> {Date}
Function XDate(__xInDate, __lDay, __lCentury, __lLong)
* XDate() - Conversin de Fechas a Formato String y viceversa.
* Desarrollo de la Funcin:  05-Ago-2004 > 06-Ago-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - AddString()
* - XAt(); No necesaria en esta funcin.
* - XDateGenerator()
*
* __xInDate    - Fecha de entrada en formatos String o Date.
* __lDay       - Mostrar da de la semana (S/No) para formato String.
* __lCentury   - Mostrar ao completo (S/No) para formato String.
* __lLong      - Mostrar fecha larga para formato String.
*
* Aviso Importante:
* - Esta funcin NO CONVIERTE formatos de fecha en tipo String al formato de fecha
*   equivalente en tipo Date si la fecha de entrada est en formato largo
*   (p.e.:  "Domingo, 08 de Agosto de 2004").
* - Necesita mandato [Set Date Italian].
*
* __cStr00   - Variable String Temporal #00.
* __cStr01   - Variable String Temporal #01.
* __cStr02   - Variable String Temporal #02.
* __cStr03   - Variable String Temporal #03.
* __cStr04   - Variable String Temporal #04.
* __cStr05   - Variable String Temporal #05.
* __xInType  - Tipo de datos de la fecha de entrada.
* __xType00  - Fecha de entrada en tipo de datos Date.
*

 Private __XDate
 Private __cStr00
 Private __cStr01
 Private __cStr02
 Private __cStr03
 Private __cStr04
 Private __cStr05
 Private __xInType
 Private __xType00

 __xInDate := IIf((Empty(__xInDate) <> .F.), Date(), __xInDate)
 __xInType :=  ValType(__xInDate)

If (__xInType <> Chr(68))
 __xInDate := AllTrim(__xInDate)
 __cStr00 := XDateGenerator(__xInDate)
 __xType00 := CToD(__cStr00)
Else
 __cStr00 := DToC(__xInDate)
 __xType00 := __xInDate
EndIf

If (__xInType <> Chr(68))
 __XDate := __xType00
Else
 __cStr01 := Right(AddString(Str(Year(__xType00)), 4, (-1), 48), IIf((__lCentury <> .F.) .Or. (__lLong <> .F.), 4, 2))
 __cStr02 := Left(CMonth(__xType00), IIf((__lLong <> .T.), 3, Len(CMonth(__xType00))))
 __cStr03 := Left(__cStr00, 2)
 __cStr04 := IIf((__lLong <> .T.), Chr(45), (Chr(32) + Chr(100) + Chr(101) + Chr(32)))
 __cStr05 := IIf((__lDay <> .F.), (Left(CDOW(__xType00), IIf((__lLong <> .T.), 3, Len(CDOW(__xType00)))) + Chr(44) + Chr(32)), Space(0))
 __XDate := (__cStr05 + __cStr03 + __cStr04 + __cStr02 + __cStr04 + __cStr01)
EndIf

 Return (__XDate)

*()> {Date}
Function XDateGenerator(__xDateGen)
* XDateGenerator() - Generador de Formatos de Fecha en Tipo String para XDate().
* Desarrollo de la Funcin:  05-Ago-2004 > 06-Ago-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - AddString(); No necesaria en esta funcin.
* - XAt()
* - XDate()
*
* Aviso Importante:
* - Necesita mandato [Set Date Italian].
*
* __xDateGen - Fecha de entrada en formato String.
*
* __cStr00   - Variable String Temporal #00.
* __cStr01   - Variable String Temporal #01.
* __cStr02   - Variable String Temporal #02.
* __cStr03   - Variable String Temporal #03.
* __nNum00   - Variable Numrica Temporal #00.
*

 Private __XGenDate
 Private __cStr00
 Private __cStr01
 Private __cStr02
 Private __cStr03
 Private __nNum00

If (ValType(__xDateGen) = Chr(67))
If (XAt(__xDateGen, (Chr(100) + Chr(101)), 0) < 1)
 __xDateGen := AllTrim(__xDateGen)
 __cStr00 := IIf((At(Chr(45), __xDateGen) > 0), Chr(45), Chr(47))
 __cStr01 := AllTrim(Right(__xDateGen, (Len(__xDateGen) - At(Chr(32), __xDateGen))))

For __nNum00 = 1 To 12 Step 1
 __cStr03 := AddString(Str(__nNum00), 2, (-1), 48)

If (XAt(__cStr01, Left(CMonth(CToD(Chr(48) + Chr(49) + Chr(45) + AddString(Str(__nNum00), 2, (-1), 48) + Chr(45) + Chr(50) + Replicate(Chr(48), 3))), 3), 0) > 0) .Or. (XAt(__cStr01, (__cStr00 + __cStr03 + __cStr00), 0) > 0)
 __cStr02 := __cStr03
EndIf
Next __nNum00

 __XGenDate := (Left(__cStr01, 2) + __cStr00 + __cStr02 + __cStr00 + Right(__cStr01, 4))
EndIf
EndIf

 Return (__XGenDate)

**********************************************************

*()> {FileIO}
Function FLnGetPos(__hFile)
* FLnGetPos() - Obtiene la posicin del puntero en un archivo.
* Desarrollo de la Funcin:  21-Abr-2004 > 21-Abr-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - FLnGoBottom()
* - FLnGoTop()
* - FReadLn()
* - FSkipLn()
* - FWriteLn()
*
* __hFile - Manejador del archivo de texto.
*

 Return (FSeek(__hFile, 0, 1))

*()> {FileIO}
Function FLnGoBottom(__hFile)
* FLnGoBottom() - Se desplaza al final de un archivo de texto.
* Desarrollo de la Funcin:  21-Abr-2004 > 21-Abr-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - FLnGetPos()
* - FLnGoTop()
* - FReadLn()
* - FSkipLn()
* - FWriteLn()
*
* __hFile - Manejador del archivo de texto.
*

 Return (FSeek(__hFile, 0, 2))

*()> {FileIO}
Function FLnGoTop(__hFile)
* FLnGoTop() - Se desplaza al inicio de un archivo de texto.
* Desarrollo de la Funcin:  21-Abr-2004 > 21-Abr-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - FLnGetPos()
* - FLnGoBottom()
* - FReadLn()
* - FSkipLn()
* - FWriteLn()
*
* __hFile - Manejador del archivo de texto.
*

 Return (FSeek(__hFile, 0, 0))

*()> {FileIO}
Function FReadLn(__hFile)
* FReadLn() - Recupera una lnea de un archivo de texto.
* Desarrollo de la Funcin:  21-Abr-2004 > 21-Abr-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - FLnGetPos()
* - FLnGoBottom()
* - FLnGoTop()
* - FSkipLn()
* - FWriteLn()
*
* __hFile       - Manejador del archivo de texto.
*
* __Buffer      - Caracter ledo del archivo.
* __Exit0       - Cdigo Primario de salida.
* __Exit1       - Cdigo Secundario de salida.
* __ReadHandler - Manejador de Lectura.
*

 Private __FReadLn
 Private __Buffer
 Private __Exit0
 Private __Exit1
 Private __ReadHandler

 __FReadLn := Space(0)
 __Buffer := Chr(32)
 __Exit0 := .F.
 __Exit1 := .F.
 __ReadHandler := 1

Do While (((__Exit0 <> .T.) .Or. (__Exit1 <> .T.)) .And. (__ReadHandler > 0))
 __ReadHandler := FRead(__hFile, @__Buffer, 1)

If (Asc(__Buffer) <> 13) .And. (Asc(__Buffer) <> 10) .And. (__ReadHandler > 0)
 __FReadLn := (__FReadLn + __Buffer)
ElseIf (Asc(__Buffer) = 13)
 __Exit0 := .T.
ElseIf (Asc(__Buffer) = 10)
 __Exit1 := .T.
ElseIf (__ReadHandler > 0)
 __Exit0 := .F.
 __Exit1 := .F.
ElseIf (__ReadHandler < 1)
 Return (Replicate(Chr(27), 1024))
EndIf
EndDo

 Return (__FReadLn)

*()> {FileIO}
Function FSkipLn(__hFile, __nLines)
* FSkipLn() - Se desplaza <#x> lneas hacia abajo en un archivo de texto.
* Desarrollo de la Funcin:  21-Abr-2004 > 21-Abr-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - FLnGetPos()
* - FLnGoBottom()
* - FLnGoTop()
* - FReadLn()
* - FWriteLn()
*
* __hFile  - Manejador del archivo de texto.
* __nLines - Nmero de lneas a desplazar el puntero.
*
* __Buffer      - Caracter ledo del archivo.
* __Exit0       - Cdigo Primario de salida.
* __Exit1       - Cdigo Secundario de salida.
* __ReadHandler - Manejador de Lectura.
*

 Private __FSkipLn
 Private __Buffer
 Private __Exit0
 Private __Exit1
 Private __ReadHandler

 __FSkipLn := 0
 __nLines := Abs(__nLines)
 __Buffer := Chr(32)
 __Exit0 := .F.
 __Exit1 := .F.
 __ReadHandler := 1

Do While ((__FSkipLn < __nLines) .And. (__ReadHandler > 0))
 __ReadHandler := FRead(__hFile, @__Buffer, 1)
 __FSkipLn := IIf((__Exit0 <> .F.) .And. (__Exit1 <> .F.), (__FSkipLn + 1), __FSkipLn)

If (Asc(__Buffer) = 13) .And. (__ReadHandler > 0)
 __Exit0 := .T.
ElseIf (Asc(__Buffer) = 10) .And. (__ReadHandler > 0)
 __Exit1 := .T.
ElseIf (__ReadHandler > 0)
 __Exit0 := .F.
 __Exit1 := .F.
EndIf
EndDo

 Return (__FSkipLn)

*()> {FileIO}
Function FWriteLn(__hFile, __cStr)
* FWriteLn() - Escribe una lnea de caracteres en un archivo de texto.
* Desarrollo de la Funcin:  21-Abr-2004 > 21-Abr-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - FLnGetPos()
* - FLnGoBottom()
* - FLnGoTop()
* - FReadLn()
* - FSkipLn()
*
* __hFile       - Manejador del archivo de texto.
* __cStr        - Cadena de caracteres para escribir en el archivo.
*
* __BytesWrited - Bytes escritos en el archivo.
* __WriteLen    - Longitud de los Bytes a escribir.
*

 Private __WriteLen
 Private __BytesWrited

 __WriteLen := 0
 __BytesWrited := 0

 __cStr := IIf((Right(__cStr, 2) <> (Chr(13) + Chr(10))), (__cStr + Chr(13) + Chr(10)), __cStr)
 __WriteLen := Len(__cStr)
 __BytesWrited := FWrite(__hFile, __cStr, __WriteLen)
 Return (IIf((__BytesWrited <> __WriteLen), .F., .T.))

**********************************************************

*()> {Math}
Function BaseXConverter(__nInput, __nBase)
* BaseXConverter() - Convertidor de Nmeros en Base Decimal a Base-X para la funcin NToC().
* Desarrollo de la Funcin:  24-Mar-2005 > 24-Mar-2005
* (c) Alejandro Padrino, 2.005
*
* AVISO IMPORTANTE:
* - Esta funcin slamente codifica y decodifica nmeros siguiendo el estndar
*   de conversiones establecido hasta Base-36.  He decidido no continuar con
*   la codificacin estndar en bases superiores a Base-36 porque me parece
*   ms correcto codificar Base-64 como la continuacin de Base-36.  Las bases
*   superiores a Base-64 estn igualmente codificadas segn el criterio que me
*   ha parecido ms correcto, ya que tambin desconozco su codificacin
*   original.
*
* Funciones Relacionadas:
* - BaseXTable()
* - CToN()  ; No necesaria en esta funcin.
* - GetValidRange()
* - NToC()  ; No necesaria en esta funcin.
* - ReverseStr()
* - StartC3()
*
* Notas:
* - Esta funcin siempre devuelve el resultado en Tipo String.
* - Los resultados pueden visualizarse si la Base-X empleada es inferior a
*   Base-240.
* - Se pueden realizar clculos empleando una Base-X hasta Base-252.
*
* __nInput    - Nmero a convertir.
* __nBase     - Base para la conversin.
*
* __cBuffer   - Buffer de resultados.
* __nCociente - Resultado de la divisin en Tipo Integer.
* __nResto    - Resto de la divisin efectuada.
*

 Local __BaseXCnv := "*** Error ***"
 Local __cBuffer := Space(0)
 Local __nDividendo := 0
 Local __nCociente := 0
 Local __nResto := 0

If (ValType(__nInput) = Chr(78))
 __nInput := Abs(Int(__nInput))
 __nBase := Abs(Int(__nBase))

If (__nInput = 0)
 __BaseXCnv := Chr(48)
ElseIf (Abs(__nInput) <= __MaxInteger) .And. (GetValidRange(__nBase, 2, 252) <> .F.)
 __BaseXCnv := Space(0)
 __nDividendo := __nInput

If (__nDividendo >= __nBase)
Do While (.T.)
 __nResto := (__nDividendo % __nBase)

If (__nDividendo < __nBase)
 __cBuffer := (__cBuffer + BaseXTable(__nCociente, __nBase))
 Exit
EndIf

 __nCociente := Int(__nDividendo / __nBase)
 __cBuffer := (__cBuffer + BaseXTable(__nResto, __nBase))
 __nDividendo := __nCociente
EndDo

Else
 __cBuffer := (__cBuffer + BaseXTable(__nDividendo, __nBase))
EndIf
EndIf
EndIf

 Return (__BaseXCnv + ReverseStr(__cBuffer))

*()> {Math}
Function BaseXTable(__xNum, __nBase)
* BaseXTable() - Conversor de Nmeros en Caracteres y viceversa para las funciones CToN() y NToC().
* Desarrollo de la Funcin:  30-Nov-2004 > 24-Mar-2005
* (c) Alejandro Padrino, 2.004
*
* AVISO IMPORTANTE:
* - Esta funcin slamente codifica y decodifica nmeros siguiendo el estndar
*   de conversiones establecido hasta Base-36.  He decidido no continuar con
*   la codificacin estndar en bases superiores a Base-36 porque me parece
*   ms correcto codificar Base-64 como la continuacin de Base-36.  Las bases
*   superiores a Base-64 estn igualmente codificadas segn el criterio que me
*   ha parecido ms correcto, ya que tambin desconozco su codificacin
*   original.
*
* Funciones Relacionadas:
* - BaseXConverter()  ; No necesaria en esta funcin.
* - CToN()  ; No necesaria en esta funcin.
* - GetValidRange()
* - NToC()  ; No necesaria en esta funcin.
* - ReverseStr()  ; No necesaria en esta funcin.
* - StartC3()  ; No necesaria en esta funcin.
*
* Notas:
* - Los resultados pueden visualizarse si la Base-X empleada es inferior a
*   Base-240.
* - Se pueden realizar clculos empleando una Base-X hasta Base-252.
*
* __xNum   - Nmero a convertir en Tipos Number o String.
* __nBase  - Base del Nmero [__xNum].
*
* __lError - Indica si se ha producido un error en la conversin.
* __cStr00 - Variable String temporal #00.
* __nNum00 - Variable numrica temporal #00.
*

 Local __BaseXTable := Nil
 Local __cStr00 := Space(0)
 Local __nNum00 := 0
 Local __lError := .F.

If (GetValidRange(__nBase, 2, 252) <> .F.)
If (ValType(__xNum) = Chr(78))
If (GetValidRange(__xNum, 0, 9) <> .F.)
 __BaseXTable := Chr(__xNum + 48)
ElseIf (GetValidRange(__xNum, 10, 35) <> .F.)
 __BaseXTable := Chr(__xNum + 55)
ElseIf (GetValidRange(__xNum, 36, 61) <> .F.)
 __BaseXTable := Chr(__xNum + 61)
ElseIf (__xNum = 62)
 __BaseXTable := Chr(43)
ElseIf (__xNum = 63)
 __BaseXTable := Chr(47)
ElseIf (GetValidRange(__xNum, 64, 196) <> .F.)
 __BaseXTable := Chr(__xNum + 59)
ElseIf (GetValidRange(__xNum, 197, 202) <> .F.)
 __BaseXTable := Chr(__xNum - 106)
ElseIf (GetValidRange(__xNum, 203, 209) <> .F.)
 __BaseXTable := Chr(__xNum - 145)
ElseIf (__xNum = 210)
 __BaseXTable := Chr(44)
ElseIf (GetValidRange(__xNum, 211, 220) <> .F.)
 __BaseXTable := Chr(__xNum - 178)
ElseIf (GetValidRange(__xNum, 221, 238) <> .F.)
 __BaseXTable := Chr(__xNum - 207)
ElseIf (GetValidRange(__xNum, 239, 251) <> .F.)
 __BaseXTable := Chr(__xNum - 238)
EndIf

ElseIf (ValType(__xNum) = Chr(67))
 __cStr00 := Left(AllTrim(__xNum), 1)
 __nNum00 := Asc(IIf((__nBase <= 36), Upper(__cStr00), __cStr00))

If (GetValidRange(__nNum00, 48, 57) <> .F.)
 __BaseXTable := (__nNum00 - 48)
ElseIf (GetValidRange(__nNum00, 65, 90) <> .F.)
 __BaseXTable := (__nNum00 - 55)
ElseIf (GetValidRange(__nNum00, 97, 122) <> .F.)
 __BaseXTable := (__nNum00 - 61)
ElseIf (__nNum00 = 43)
 __BaseXTable := (62)
ElseIf (__nNum00 = 47)
 __BaseXTable := (63)
ElseIf (GetValidRange(__nNum00, 123, 255) <> .F.)
 __BaseXTable := (__nNum00 - 59)
ElseIf (GetValidRange(__nNum00, 91, 96) <> .F.)
 __BaseXTable := (__nNum00 + 106)
ElseIf (GetValidRange(__nNum00, 58, 64) <> .F.)
 __BaseXTable := (__nNum00 + 145)
ElseIf (__nNum00 = 44)
 __BaseXTable := (210)
ElseIf (GetValidRange(__nNum00, 33, 42) <> .F.)
 __BaseXTable := (__nNum00 + 178)
ElseIf (GetValidRange(__nNum00, 14, 31) <> .F.)
 __BaseXTable := (__nNum00 + 207)
ElseIf (GetValidRange(__nNum00, 1, 13) <> .F.)
 __BaseXTable := (__nNum00 + 238)
EndIf

 __lError := IIf((__BaseXTable < __nBase), __lError, .T.)
EndIf
EndIf

 Return (IIf((__lError <> .T.), __BaseXTable, "*** Error ***"))

*()> {Math}
Function CToN(__cInput, __nBase)
* CToN() - Conversin de Nmeros en Base-X a Base Decimal.
* Desarrollo de la Funcin:  30-Nov-2004 > 24-Mar-2005
* (c) Alejandro Padrino, 2.004
*
* AVISO IMPORTANTE:
* - Esta funcin slamente codifica y decodifica nmeros siguiendo el estndar
*   de conversiones establecido hasta Base-36.  He decidido no continuar con
*   la codificacin estndar en bases superiores a Base-36 porque me parece
*   ms correcto codificar Base-64 como la continuacin de Base-36.  Las bases
*   superiores a Base-64 estn igualmente codificadas segn el criterio que me
*   ha parecido ms correcto, ya que tambin desconozco su codificacin
*   original.
*
* Funciones Relacionadas:
* - BaseXConverter()  ; No necesaria en esta funcin.
* - BaseXTable()
* - GetValidRange()  ; No necesaria en esta funcin.
* - NToC()  ; No necesaria en esta funcin.
* - ReverseStr()
* - StartC3()  ; No necesaria en esta funcin.
*
* Notas:
* - Esta funcin siempre devuelve el resultado en Tipo Number.
* - No estn includos todos los lmites numricos para cada Base-X.
* - Se pueden realizar clculos empleando una Base-X hasta Base-252.
*
* __cInput    - Nmero a convertir.
* __nBase     - Base para la conversin.
*
* __cBuffer   - Buffer de dgitos a convertir.
* __nExp      - Exponente para los clculos de conversin.
* __nFraction - Valor que representa la parte decimal del nmero a convertir.
* __nDecimals - Valor numrico que indica si el nmero contiene decimales.
* __lNegativo - Valor lgico que indica si el nmero es negativo.
* __nNum00    - Variable numrica temporal #00.
*

 Local __CToN := 0
 Local __cBuffer := Space(0)
 Local __nExp := 0
 Local __nDecimals := 0
 Local __nFraction := 0
 Local __nNum00 := 0
 Local __lNegativo := .F.

If (ValType(__cInput) = Chr(67))
 __cInput := AllTrim(__cInput)
 __nBase := Abs(Int(__nBase))

If (__nBase <= 252)
If (Left(__cInput, 1) = Chr(45))
 __lNegativo := .T.
 __cInput := Right(__cInput, (Len(__cInput) - 1))
EndIf

 __cBuffer := ReverseStr(__cInput)
 __nDecimals := (At(Chr(46), __cBuffer) - 1)

If (__nDecimals > 0)
For __nExp = 0 To (__nDecimals - 1) Step 1
 __nNum00 := (__nNum00 + (BaseXTable(SubStr(__cBuffer, (__nExp + 1), 1), __nBase) * (__nBase ^ __nExp)))
Next __nExp

 __nFraction := Val(Chr(48) + Chr(46) + AllTrim(Str(__nNum00)))
 __cBuffer := ReverseStr(Left(__cInput, (At(Chr(46), __cInput) - 1)))
EndIf

For __nExp = 0 To (Len(__cBuffer) - 1) Step 1
 __CToN := (__CToN + (BaseXTable(SubStr(__cBuffer, (__nExp + 1), 1), __nBase) * (__nBase ^ __nExp)))
Next __nExp

 __CToN := (__CToN + __nFraction)
EndIf
EndIf

 Return (IIf((__lNegativo <> .F.), (__CToN * (-1)), __CToN))

*()> {Math}
Function GetValidRange(__nInput, __nMin, __nMax)
* GetValidRange() - Evala si el Valor de un Nmero est entre dos valores incicados.
* Desarrollo de la Funcin:  05-Ago-2004 > 05-Ago-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - (Ninguna)
*
* __nInput - Nmero a evaluar.
* __nMin   - Valor mnimo.
* __nMax   - Valor mximo.
*

 Return (IIf((__nInput >= 0) .And. (__nInput >= __nMin) .And. (__nInput <= __nMax), .T., If((__nInput < 0) .And. (__nInput <= __nMin) .And. (__nInput >= __nMax), .T., .F.)))

*()> {Math}
Function NToC(__nInput, __nBase)
* NToC() - Conversin de Nmeros en Base Decimal a Base-X.
* Desarrollo de la Funcin:  30-Nov-2004 > 24-Mar-2005
* (c) Alejandro Padrino, 2.004
*
* AVISO IMPORTANTE:
* - Esta funcin slamente codifica y decodifica nmeros siguiendo el estndar
*   de conversiones establecido hasta Base-36.  He decidido no continuar con
*   la codificacin estndar en bases superiores a Base-36 porque me parece
*   ms correcto codificar Base-64 como la continuacin de Base-36.  Las bases
*   superiores a Base-64 estn igualmente codificadas segn el criterio que me
*   ha parecido ms correcto, ya que tambin desconozco su codificacin
*   original.
*
* Funciones Relacionadas:
* - BaseXConverter()
* - BaseXTable()  ; No necesaria en esta funcin.
* - CToN()  ; No necesaria en esta funcin.
* - GetValidRange()  ; No necesaria en esta funcin.
* - ReverseStr()  ; No necesaria en esta funcin.
* - StartC3()  ; No necesaria en esta funcin.
*
* Notas:
* - Esta funcin siempre devuelve el resultado en Tipo String.
* - No estn includos todos los lmites numricos para cada Base-X.
* - Los resultados pueden visualizarse si la Base-X empleada es inferior a
*   Base-240.
* - Se pueden realizar clculos empleando una Base-X hasta Base-252.
*
* __nInput    - Nmero a convertir.
* __nBase     - Base para la conversin.
*
* __cFraction - Parte decimal del nmero a convertir.
* __lNegativo - Valor lgico que indica si el nmero es negativo.
* __cStr00    - Variable String temporal #00.
* __nNum00    - Variable numrica temporal #00.
*

 Local __NToC := "*** Error ***"
 Local __cFraction := Space(0)
 Local __lNegativo := IIf((__nInput < 0), .T., .F.)
 Local __cStr00 := Space(0)
 Local __nNum00 := Abs(__nInput)

If (ValType(__nInput) = Chr(78))
 __cStr00 := Transform((__nNum00 - Int(__nNum00)), "####################.####################")
 __nNum00 := Val(SubStr(__cStr00, (At(Chr(46), __cStr00) + 1), (Set(3, Nil, Nil) + 1)))
 __cFraction := IIf((__nNum00 > 0), (Chr(46) + BaseXConverter(__nNum00, __nBase)), Space(0))
 __NToC := (IIf((__lNegativo <> .F.), Chr(45), Space(0)) + BaseXConverter(__nInput, __nBase) + __cFraction)
EndIf

 Return (__NToC)

**********************************************************

*()> {Memory}
Function ArraySize(__nSet, __lMBytes)
* ArraySize() - Configura o Devuelve el Valor de la variable [__MaxArraySize] en MBytes o KBytes.
* Desarrollo de la Funcin:  29-Nov-2004 > 29-Nov-2004
* (c) Alejandro Padrino, 2.004
*
* Notas:
* - El nmero de elementos de un array en C3 depende de la cantidad de
*   memoria RAM disponible.  En la funcin StartC3() se ha definido una
*   variable llamada [__MaxArraySize] que sirve para controlar en otras
*   funciones los elementos que puede contener un array.  El valor de
*   esta variable se establece por defecto en [1.048.576] elementos, y
*   en un PC con 128 MBytes de RAM puede tomar, aproximadamente, un
*   valor de unos [8.388.608] elementos.
*
* - Esta funcin devuelve el valor de la variable [__MaxArraySize]
*   antes de que sea cambiado.
*
* Funciones Relacionadas:
* - StartC3()
*
* __nSet    - Valor en MBytes o KBytes que tomar la variable [__MaxArraySize].
* __lMBytes - Valor lgico que indica si el valor establecido o devuelto se indicar en MBytes (.T.) o KBytes (.F.).
*
* __nFactor - Mltiplo a establecer dependiendo del valor de [__lMBytes].
*

 Private __ArraySize := __MaxArraySize
 Private __nFactor := IIf((__lMBytes <> .F.), 1048576, 1024)

If (__nSet > 0)
 __nSet := Int(__nSet)
 __MaxArraySize := (__nSet * __nFactor)
EndIf

 Return (__ArraySize / __nFactor)

**********************************************************

*()> {String}
Function AddString(__cStr, __nLen, __nPos, __nAscii)
* AddString() - Formato de Cadenas de Caracteres a una longitud determinada.
* Desarrollo de la Funcin:  05-Ago-2004 > 06-Ago-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - (Ninguna)
*
* __cStr    - Cadena de Caracteres a modificar.
* __nLen    - Longitud deseada.
* __nPos    - Posicin donde se insertarn los caracteres;
*             (-1) = Izquierda  /  (+1) = Derecha
* __nAscii  - Nmero del Caracter ASCII que se insertar.
*
* __nNum00  - Variable Numrica temporal #00.
* __cStr00  - Variable String temporal #00.
*

 Private __nNum00
 Private __cStr00

 __cStr := AllTrim(__cStr)
 __nNum00 := (Abs(__nLen) - Len(__cStr))
 __cStr00 := If((__nNum00 > 0), Replicate(Chr(__nAscii), __nNum00), Space(0))
 Return (Left(If((__nPos < 0), (__cStr00 + __cStr), (__cStr + __cStr00)), __nLen))

*()> {String}
Function CRLF(__nLines)
* CRLF() - Genera tantos CR+LF como se indiquen.
* Desarrollo de la Funcin:  23-Oct-2004 > 23-Oct-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - (Ninguna)
*
* __nLines - Nmero de CR+LF a generar.
*

 Return (Replicate((Chr(13) + Chr(10)), __nLines))

*()> {String}
Function ReverseStr(__cInput)
* ReverseStr() - Devuelve una Cadena de Caracteres en orden inverso.
* Desarrollo de la Funcin:  01-Dic-2004 > 01-Dic-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - (Ninguna)
*
* __nNum00 - Variable numrica temporal #00.
*

 Local __ReverseStr := Space(0)
 Local __nNum00 := 0

For __nNum00 = Len(__cInput) To 1 Step (-1)
 __ReverseStr := (__ReverseStr + SubStr(__cInput, __nNum00, 1))
Next __nNum00

 Return (__ReverseStr)

*()> {String}
Function SpcString(__cStr, __nLen)
* SpcString() - Devuelve una Cadena de Caracteres en la Longitud Indicada.
* Desarrollo de la Funcin:  07-Ago-2004 > 07-Ago-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - AddString()
*
* Aviso Importante:
* - Esta funcin NO INSERTA lneas de texto vacas en la matriz.
*
* __cStr - Cadena de Caracteres.
* __nLen - Longitud Indicada.
*

 Return (AddString(__cStr, __nLen, 1, 32))

*()> {String}
Function Str2Bin(__cStr)
* Str2Bin() - Convierte la cadena de entrada a su equivalente en binario.
* Desarrollo de la Funcin:  03-Dic-2005 > 03-Dic-05
* (c) Alejandro Padrino, 2.005
*
* Funciones Relacionadas:
* - AddString()
* - BaseXConverter()
* - BaseXTable()
* - Compress()
* - CToN()
* - DeCompress()
* - GetValidRange()
* - NToC()
* - ReverseStr()
* - StartClp()
*
* __cStr  - Cadena de Caracteres a convertir.
*
* __cOut  - Caracteres convertidos.
* __nChar - Nmero del caracter ASCII ledo.
* __nB00  - Bucle nmero #00.
*

 Local __cOut := Space(0)
 Local __nChar := 0
 Local __nB00 := 0

For __nB00 = 1 To Len(__cStr) Step 1
 __nChar := Asc(SubStr(__cStr, __nB00, 1))
 __cOut := (__cOut + AddString(NToC(__nChar, 2), 8, (-1), 48))
Next __nB00

 Return (__cOut)

*()> {String}
Function Str2Dec(__cStr, __bCode)
* Str2Dec() - Convierte la cadena de entrada a su equivalente en decimal.
* Desarrollo de la Funcin:  04-Dic-2005 > 21-Dic-05
* (c) Alejandro Padrino, 2.005
*
* Funciones Relacionadas:
* - AddString()
* - Compress()
* - DeCompress()
*
* __cStr    - Cadena de Caracteres a convertir.
* __bCode   - Valor lgico que indica si la cadena de devolver como una
*             Expresin de Caracteres en Cdigo de C3.
*
* __cOut    - Caracteres convertidos.
* __nChar   - Nmero del caracter ASCII ledo.
* __cBegTop - Caracter de inicio de la expresin de caracteres devuelta.
* __cTop    - Caracter indicador de la funcin de cdigo.
* __cAnd    - Caracter del operador de suma.
* __cSpc    - Caracter indicador de un espacio.
* __cEndBot - Caracter final de la expresin de caracteres devuelta.
* __cBot    - Caracter final de la funcin de cdigo.
* __nB00    - Bucle nmero #00.
*

 Local __cOut := Space(0)
 Local __nChar := 0
 Local __cBegTop := IIf((__bCode <> .F.), Chr(40), Space(0))
 Local __cTop := IIf((__bCode <> .F.), (Chr(67) + Chr(104) + Chr(114) + Chr(40)), Space(0))
 Local __cAnd := IIf((__bCode <> .F.), Chr(43), Space(0))
 Local __cSpc := IIf((__bCode <> .F.), Chr(32), Space(0))
 Local __cEndBot := IIf((__bCode <> .F.), Chr(41), Space(0))
 Local __cBot := IIf((__bCode <> .F.), Chr(41), Space(0))
 Local __nB00 := 0

 __cOut := __cBegTop

For __nB00 = 1 To Len(__cStr) Step 1
 __nChar := Asc(SubStr(__cStr, __nB00, 1))
 __cOut := (__cOut + __cTop + AddString(AllTrim(Str(__nChar, 3, 0)), 3, (-1), 48) + __cBot + IIf((__nB00 < Len(__cStr)), (__cSpc + __cAnd + __cSpc), Space(0)))
Next __nB00

 __cOut := (__cOut + __cEndBot)

 Return (__cOut)

*()> {String}
Function StrToArray(__cStr)
* StrToArray() - Extrae las lneas de texto de una cadena de caracteres en una matriz.
* Desarrollo de la Funcin:  07-Ago-2004 > 10-Dic-2004
* (c) Alejandro Padrino, 2.004
*
* Funciones Relacionadas:
* - StartC3()
*
* __cStr   - Cadena de caracteres.
*
* __Buffer - Caracter ledo del archivo.
* __cLine  - Lnea leda de la cadena de caracteres.
* __lSw00  - Variable Lgica Temporal #00.
* __nNum00 - Variable Numrica Temporal #00.
* __nNum01 - Variable Numrica Temporal #01.
*

 Private __StrToArray := {}
 Private __Buffer
 Private __cLine
 Private __lSw00
 Private __nNum00
 Private __nNum01

 __cLine := Space(0)
 __Buffer := Chr(32)
 __nNum01 := 0
 __lSw00 := .F.

For __nNum00 = 1 To Len(__cStr) Step 1
 __Buffer := SubStr(__cStr, __nNum00, 1)

If (Asc(__Buffer) <> 13) .And. (Asc(__Buffer) <> 10)
 __cLine := (__cLine + __Buffer)
 __lSw00 := .T.
ElseIf (__lSw00 <> .F.) .And. (__nNum01 <= __MaxArraySize) .And. ((Asc(__Buffer) = 13) .Or. (Asc(__Buffer) = 10))
 AAdd(__StrToArray, __cLine)
 __nNum01 := (__nNum01 + 1)
 __cLine := Space(0)
 __lSw00 := .F.
EndIf
Next __nNum00

 AAdd(__StrToArray, __cLine)
 Return (__StrToArray)

*()> {String}
Function XAt(__cStr, __cSch, __nExt)
* XAt() - Bsqueda de Caracteres en datos de tipo String.
* Desarrollo de la Funcin:  05-Ago-2004 > 13-Sep-2005
* (c) Alejandro Padrino, 2.004 - 2.005
*
* Funciones Relacionadas:
* - XSchCnv()
*
* __cStr - Cadena de Caracteres.
* __cSch - Caracteres a buscar.
* __nExt - Buscar ignorando maysculas, minsculas, acentos y smbolos.
*

 __cStr := IIf((__nExt > 0), XSchCnv(__cStr, __nExt), __cStr)
 Return (At(Lower(__cSch), Lower(__cStr)))

*()> {String}
Function XGenStr(__nLen, __aCmd)
* XGenStr() - Generador de Cadenas de Caracteres (hasta 256 Bytes) y Ejecutor de Comandos xBase.
* Desarrollo de la Funcin:  04-Sep-2005 > 21-May-2006
* (c) Alejandro Padrino, 2.005 - 2.006
*
* Funciones Relacionadas:
* - ExecuteCmd()
*
* __nLen - Aceptar slamente cadenas generadas de la longitud indicada.
* __aCmd - Array de comandos para ejecutar.
*
* __aG[]        - Array de Caracteres Generados.
* __aBucle[]    - Array de Bucles.
* __aNotBucle[] - Array para la Seleccin de Longitud de la Cadena Generada.
* __aTemp[]     - Array Temporal para la Suma de los Caracteres Generados.
* __nSetCmd     - Nmero de Comandos a Ejecutar.
* __nLenGen     - Longitud de la Cadena de Caracteres generada.
* __nB00        - Variable Temporal #00.
*
* Variables Privadas Creadas:
* __XGenStr[] - Array de Estado de la funcin.
*               [1]> Contiene la Cadena de Caracteres generada.
*               [2]> Contiene el valor del ltimo bucle.
*

 Local __nLenGen := 256
 Local __aG[__nLenGen]
 Local __aBucle[__nLenGen + 1]
 Local __aNotBucle[__nLenGen]
 Local __aTemp[16]
 Local __nSetCmd := Len(__aCmd)
 Local __nB00 := 0

 Private __XGenStr[2]
 __XGenStr[1] := Space(0)
 __XGenStr[2] := 0

 __nLen := IIf((Empty(__nLen) <> .F.), __nLenGen, __nLen)

For __nB00 = 1 To __nLenGen Step 1
 __aNotBucle[__nB00] := IIf((__nB00 > (__nLen + 1)), .F., .T.)
Next __nB00

 __aBucle[001] := (-1)
 __aBucle[__nLen] := (-1)

For __aBucle[256] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[256] := IIf((__aNotBucle[256] <> .T.), 255, __aBucle[256])
 __aG[256] := IIf((__aBucle[256] < 0) .Or. (__aNotBucle[256] <> .T.), Space(0), Chr(__aBucle[256]))

For __aBucle[255] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[255] := IIf((__aNotBucle[255] <> .T.), 255, __aBucle[255])
 __aG[255] := IIf((__aBucle[255] < 0) .Or. (__aNotBucle[255] <> .T.), Space(0), Chr(__aBucle[255]))

For __aBucle[254] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[254] := IIf((__aNotBucle[254] <> .T.), 255, __aBucle[254])
 __aG[254] := IIf((__aBucle[254] < 0) .Or. (__aNotBucle[254] <> .T.), Space(0), Chr(__aBucle[254]))

For __aBucle[253] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[253] := IIf((__aNotBucle[253] <> .T.), 255, __aBucle[253])
 __aG[253] := IIf((__aBucle[253] < 0) .Or. (__aNotBucle[253] <> .T.), Space(0), Chr(__aBucle[253]))

For __aBucle[252] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[252] := IIf((__aNotBucle[252] <> .T.), 255, __aBucle[252])
 __aG[252] := IIf((__aBucle[252] < 0) .Or. (__aNotBucle[252] <> .T.), Space(0), Chr(__aBucle[252]))

For __aBucle[251] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[251] := IIf((__aNotBucle[251] <> .T.), 255, __aBucle[251])
 __aG[251] := IIf((__aBucle[251] < 0) .Or. (__aNotBucle[251] <> .T.), Space(0), Chr(__aBucle[251]))

For __aBucle[250] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[250] := IIf((__aNotBucle[250] <> .T.), 255, __aBucle[250])
 __aG[250] := IIf((__aBucle[250] < 0) .Or. (__aNotBucle[250] <> .T.), Space(0), Chr(__aBucle[250]))

For __aBucle[249] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[249] := IIf((__aNotBucle[249] <> .T.), 255, __aBucle[249])
 __aG[249] := IIf((__aBucle[249] < 0) .Or. (__aNotBucle[249] <> .T.), Space(0), Chr(__aBucle[249]))

For __aBucle[248] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[248] := IIf((__aNotBucle[248] <> .T.), 255, __aBucle[248])
 __aG[248] := IIf((__aBucle[248] < 0) .Or. (__aNotBucle[248] <> .T.), Space(0), Chr(__aBucle[248]))

For __aBucle[247] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[247] := IIf((__aNotBucle[247] <> .T.), 255, __aBucle[247])
 __aG[247] := IIf((__aBucle[247] < 0) .Or. (__aNotBucle[247] <> .T.), Space(0), Chr(__aBucle[247]))

For __aBucle[246] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[246] := IIf((__aNotBucle[246] <> .T.), 255, __aBucle[246])
 __aG[246] := IIf((__aBucle[246] < 0) .Or. (__aNotBucle[246] <> .T.), Space(0), Chr(__aBucle[246]))

For __aBucle[245] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[245] := IIf((__aNotBucle[245] <> .T.), 255, __aBucle[245])
 __aG[245] := IIf((__aBucle[245] < 0) .Or. (__aNotBucle[245] <> .T.), Space(0), Chr(__aBucle[245]))

For __aBucle[244] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[244] := IIf((__aNotBucle[244] <> .T.), 255, __aBucle[244])
 __aG[244] := IIf((__aBucle[244] < 0) .Or. (__aNotBucle[244] <> .T.), Space(0), Chr(__aBucle[244]))

For __aBucle[243] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[243] := IIf((__aNotBucle[243] <> .T.), 255, __aBucle[243])
 __aG[243] := IIf((__aBucle[243] < 0) .Or. (__aNotBucle[243] <> .T.), Space(0), Chr(__aBucle[243]))

For __aBucle[242] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[242] := IIf((__aNotBucle[242] <> .T.), 255, __aBucle[242])
 __aG[242] := IIf((__aBucle[242] < 0) .Or. (__aNotBucle[242] <> .T.), Space(0), Chr(__aBucle[242]))

For __aBucle[241] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[241] := IIf((__aNotBucle[241] <> .T.), 255, __aBucle[241])
 __aG[241] := IIf((__aBucle[241] < 0) .Or. (__aNotBucle[241] <> .T.), Space(0), Chr(__aBucle[241]))

For __aBucle[240] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[240] := IIf((__aNotBucle[240] <> .T.), 255, __aBucle[240])
 __aG[240] := IIf((__aBucle[240] < 0) .Or. (__aNotBucle[240] <> .T.), Space(0), Chr(__aBucle[240]))

For __aBucle[239] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[239] := IIf((__aNotBucle[239] <> .T.), 255, __aBucle[239])
 __aG[239] := IIf((__aBucle[239] < 0) .Or. (__aNotBucle[239] <> .T.), Space(0), Chr(__aBucle[239]))

For __aBucle[238] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[238] := IIf((__aNotBucle[238] <> .T.), 255, __aBucle[238])
 __aG[238] := IIf((__aBucle[238] < 0) .Or. (__aNotBucle[238] <> .T.), Space(0), Chr(__aBucle[238]))

For __aBucle[237] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[237] := IIf((__aNotBucle[237] <> .T.), 255, __aBucle[237])
 __aG[237] := IIf((__aBucle[237] < 0) .Or. (__aNotBucle[237] <> .T.), Space(0), Chr(__aBucle[237]))

For __aBucle[236] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[236] := IIf((__aNotBucle[236] <> .T.), 255, __aBucle[236])
 __aG[236] := IIf((__aBucle[236] < 0) .Or. (__aNotBucle[236] <> .T.), Space(0), Chr(__aBucle[236]))

For __aBucle[235] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[235] := IIf((__aNotBucle[235] <> .T.), 255, __aBucle[235])
 __aG[235] := IIf((__aBucle[235] < 0) .Or. (__aNotBucle[235] <> .T.), Space(0), Chr(__aBucle[235]))

For __aBucle[234] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[234] := IIf((__aNotBucle[234] <> .T.), 255, __aBucle[234])
 __aG[234] := IIf((__aBucle[234] < 0) .Or. (__aNotBucle[234] <> .T.), Space(0), Chr(__aBucle[234]))

For __aBucle[233] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[233] := IIf((__aNotBucle[233] <> .T.), 255, __aBucle[233])
 __aG[233] := IIf((__aBucle[233] < 0) .Or. (__aNotBucle[233] <> .T.), Space(0), Chr(__aBucle[233]))

For __aBucle[232] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[232] := IIf((__aNotBucle[232] <> .T.), 255, __aBucle[232])
 __aG[232] := IIf((__aBucle[232] < 0) .Or. (__aNotBucle[232] <> .T.), Space(0), Chr(__aBucle[232]))

For __aBucle[231] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[231] := IIf((__aNotBucle[231] <> .T.), 255, __aBucle[231])
 __aG[231] := IIf((__aBucle[231] < 0) .Or. (__aNotBucle[231] <> .T.), Space(0), Chr(__aBucle[231]))

For __aBucle[230] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[230] := IIf((__aNotBucle[230] <> .T.), 255, __aBucle[230])
 __aG[230] := IIf((__aBucle[230] < 0) .Or. (__aNotBucle[230] <> .T.), Space(0), Chr(__aBucle[230]))

For __aBucle[229] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[229] := IIf((__aNotBucle[229] <> .T.), 255, __aBucle[229])
 __aG[229] := IIf((__aBucle[229] < 0) .Or. (__aNotBucle[229] <> .T.), Space(0), Chr(__aBucle[229]))

For __aBucle[228] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[228] := IIf((__aNotBucle[228] <> .T.), 255, __aBucle[228])
 __aG[228] := IIf((__aBucle[228] < 0) .Or. (__aNotBucle[228] <> .T.), Space(0), Chr(__aBucle[228]))

For __aBucle[227] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[227] := IIf((__aNotBucle[227] <> .T.), 255, __aBucle[227])
 __aG[227] := IIf((__aBucle[227] < 0) .Or. (__aNotBucle[227] <> .T.), Space(0), Chr(__aBucle[227]))

For __aBucle[226] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[226] := IIf((__aNotBucle[226] <> .T.), 255, __aBucle[226])
 __aG[226] := IIf((__aBucle[226] < 0) .Or. (__aNotBucle[226] <> .T.), Space(0), Chr(__aBucle[226]))

For __aBucle[225] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[225] := IIf((__aNotBucle[225] <> .T.), 255, __aBucle[225])
 __aG[225] := IIf((__aBucle[225] < 0) .Or. (__aNotBucle[225] <> .T.), Space(0), Chr(__aBucle[225]))

For __aBucle[224] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[224] := IIf((__aNotBucle[224] <> .T.), 255, __aBucle[224])
 __aG[224] := IIf((__aBucle[224] < 0) .Or. (__aNotBucle[224] <> .T.), Space(0), Chr(__aBucle[224]))

For __aBucle[223] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[223] := IIf((__aNotBucle[223] <> .T.), 255, __aBucle[223])
 __aG[223] := IIf((__aBucle[223] < 0) .Or. (__aNotBucle[223] <> .T.), Space(0), Chr(__aBucle[223]))

For __aBucle[222] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[222] := IIf((__aNotBucle[222] <> .T.), 255, __aBucle[222])
 __aG[222] := IIf((__aBucle[222] < 0) .Or. (__aNotBucle[222] <> .T.), Space(0), Chr(__aBucle[222]))

For __aBucle[221] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[221] := IIf((__aNotBucle[221] <> .T.), 255, __aBucle[221])
 __aG[221] := IIf((__aBucle[221] < 0) .Or. (__aNotBucle[221] <> .T.), Space(0), Chr(__aBucle[221]))

For __aBucle[220] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[220] := IIf((__aNotBucle[220] <> .T.), 255, __aBucle[220])
 __aG[220] := IIf((__aBucle[220] < 0) .Or. (__aNotBucle[220] <> .T.), Space(0), Chr(__aBucle[220]))

For __aBucle[219] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[219] := IIf((__aNotBucle[219] <> .T.), 255, __aBucle[219])
 __aG[219] := IIf((__aBucle[219] < 0) .Or. (__aNotBucle[219] <> .T.), Space(0), Chr(__aBucle[219]))

For __aBucle[218] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[218] := IIf((__aNotBucle[218] <> .T.), 255, __aBucle[218])
 __aG[218] := IIf((__aBucle[218] < 0) .Or. (__aNotBucle[218] <> .T.), Space(0), Chr(__aBucle[218]))

For __aBucle[217] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[217] := IIf((__aNotBucle[217] <> .T.), 255, __aBucle[217])
 __aG[217] := IIf((__aBucle[217] < 0) .Or. (__aNotBucle[217] <> .T.), Space(0), Chr(__aBucle[217]))

For __aBucle[216] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[216] := IIf((__aNotBucle[216] <> .T.), 255, __aBucle[216])
 __aG[216] := IIf((__aBucle[216] < 0) .Or. (__aNotBucle[216] <> .T.), Space(0), Chr(__aBucle[216]))

For __aBucle[215] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[215] := IIf((__aNotBucle[215] <> .T.), 255, __aBucle[215])
 __aG[215] := IIf((__aBucle[215] < 0) .Or. (__aNotBucle[215] <> .T.), Space(0), Chr(__aBucle[215]))

For __aBucle[214] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[214] := IIf((__aNotBucle[214] <> .T.), 255, __aBucle[214])
 __aG[214] := IIf((__aBucle[214] < 0) .Or. (__aNotBucle[214] <> .T.), Space(0), Chr(__aBucle[214]))

For __aBucle[213] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[213] := IIf((__aNotBucle[213] <> .T.), 255, __aBucle[213])
 __aG[213] := IIf((__aBucle[213] < 0) .Or. (__aNotBucle[213] <> .T.), Space(0), Chr(__aBucle[213]))

For __aBucle[212] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[212] := IIf((__aNotBucle[212] <> .T.), 255, __aBucle[212])
 __aG[212] := IIf((__aBucle[212] < 0) .Or. (__aNotBucle[212] <> .T.), Space(0), Chr(__aBucle[212]))

For __aBucle[211] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[211] := IIf((__aNotBucle[211] <> .T.), 255, __aBucle[211])
 __aG[211] := IIf((__aBucle[211] < 0) .Or. (__aNotBucle[211] <> .T.), Space(0), Chr(__aBucle[211]))

For __aBucle[210] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[210] := IIf((__aNotBucle[210] <> .T.), 255, __aBucle[210])
 __aG[210] := IIf((__aBucle[210] < 0) .Or. (__aNotBucle[210] <> .T.), Space(0), Chr(__aBucle[210]))

For __aBucle[209] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[209] := IIf((__aNotBucle[209] <> .T.), 255, __aBucle[209])
 __aG[209] := IIf((__aBucle[209] < 0) .Or. (__aNotBucle[209] <> .T.), Space(0), Chr(__aBucle[209]))

For __aBucle[208] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[208] := IIf((__aNotBucle[208] <> .T.), 255, __aBucle[208])
 __aG[208] := IIf((__aBucle[208] < 0) .Or. (__aNotBucle[208] <> .T.), Space(0), Chr(__aBucle[208]))

For __aBucle[207] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[207] := IIf((__aNotBucle[207] <> .T.), 255, __aBucle[207])
 __aG[207] := IIf((__aBucle[207] < 0) .Or. (__aNotBucle[207] <> .T.), Space(0), Chr(__aBucle[207]))

For __aBucle[206] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[206] := IIf((__aNotBucle[206] <> .T.), 255, __aBucle[206])
 __aG[206] := IIf((__aBucle[206] < 0) .Or. (__aNotBucle[206] <> .T.), Space(0), Chr(__aBucle[206]))

For __aBucle[205] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[205] := IIf((__aNotBucle[205] <> .T.), 255, __aBucle[205])
 __aG[205] := IIf((__aBucle[205] < 0) .Or. (__aNotBucle[205] <> .T.), Space(0), Chr(__aBucle[205]))

For __aBucle[204] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[204] := IIf((__aNotBucle[204] <> .T.), 255, __aBucle[204])
 __aG[204] := IIf((__aBucle[204] < 0) .Or. (__aNotBucle[204] <> .T.), Space(0), Chr(__aBucle[204]))

For __aBucle[203] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[203] := IIf((__aNotBucle[203] <> .T.), 255, __aBucle[203])
 __aG[203] := IIf((__aBucle[203] < 0) .Or. (__aNotBucle[203] <> .T.), Space(0), Chr(__aBucle[203]))

For __aBucle[202] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[202] := IIf((__aNotBucle[202] <> .T.), 255, __aBucle[202])
 __aG[202] := IIf((__aBucle[202] < 0) .Or. (__aNotBucle[202] <> .T.), Space(0), Chr(__aBucle[202]))

For __aBucle[201] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[201] := IIf((__aNotBucle[201] <> .T.), 255, __aBucle[201])
 __aG[201] := IIf((__aBucle[201] < 0) .Or. (__aNotBucle[201] <> .T.), Space(0), Chr(__aBucle[201]))

For __aBucle[200] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[200] := IIf((__aNotBucle[200] <> .T.), 255, __aBucle[200])
 __aG[200] := IIf((__aBucle[200] < 0) .Or. (__aNotBucle[200] <> .T.), Space(0), Chr(__aBucle[200]))

For __aBucle[199] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[199] := IIf((__aNotBucle[199] <> .T.), 255, __aBucle[199])
 __aG[199] := IIf((__aBucle[199] < 0) .Or. (__aNotBucle[199] <> .T.), Space(0), Chr(__aBucle[199]))

For __aBucle[198] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[198] := IIf((__aNotBucle[198] <> .T.), 255, __aBucle[198])
 __aG[198] := IIf((__aBucle[198] < 0) .Or. (__aNotBucle[198] <> .T.), Space(0), Chr(__aBucle[198]))

For __aBucle[197] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[197] := IIf((__aNotBucle[197] <> .T.), 255, __aBucle[197])
 __aG[197] := IIf((__aBucle[197] < 0) .Or. (__aNotBucle[197] <> .T.), Space(0), Chr(__aBucle[197]))

For __aBucle[196] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[196] := IIf((__aNotBucle[196] <> .T.), 255, __aBucle[196])
 __aG[196] := IIf((__aBucle[196] < 0) .Or. (__aNotBucle[196] <> .T.), Space(0), Chr(__aBucle[196]))

For __aBucle[195] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[195] := IIf((__aNotBucle[195] <> .T.), 255, __aBucle[195])
 __aG[195] := IIf((__aBucle[195] < 0) .Or. (__aNotBucle[195] <> .T.), Space(0), Chr(__aBucle[195]))

For __aBucle[194] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[194] := IIf((__aNotBucle[194] <> .T.), 255, __aBucle[194])
 __aG[194] := IIf((__aBucle[194] < 0) .Or. (__aNotBucle[194] <> .T.), Space(0), Chr(__aBucle[194]))

For __aBucle[193] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[193] := IIf((__aNotBucle[193] <> .T.), 255, __aBucle[193])
 __aG[193] := IIf((__aBucle[193] < 0) .Or. (__aNotBucle[193] <> .T.), Space(0), Chr(__aBucle[193]))

For __aBucle[192] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[192] := IIf((__aNotBucle[192] <> .T.), 255, __aBucle[192])
 __aG[192] := IIf((__aBucle[192] < 0) .Or. (__aNotBucle[192] <> .T.), Space(0), Chr(__aBucle[192]))

For __aBucle[191] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[191] := IIf((__aNotBucle[191] <> .T.), 255, __aBucle[191])
 __aG[191] := IIf((__aBucle[191] < 0) .Or. (__aNotBucle[191] <> .T.), Space(0), Chr(__aBucle[191]))

For __aBucle[190] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[190] := IIf((__aNotBucle[190] <> .T.), 255, __aBucle[190])
 __aG[190] := IIf((__aBucle[190] < 0) .Or. (__aNotBucle[190] <> .T.), Space(0), Chr(__aBucle[190]))

For __aBucle[189] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[189] := IIf((__aNotBucle[189] <> .T.), 255, __aBucle[189])
 __aG[189] := IIf((__aBucle[189] < 0) .Or. (__aNotBucle[189] <> .T.), Space(0), Chr(__aBucle[189]))

For __aBucle[188] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[188] := IIf((__aNotBucle[188] <> .T.), 255, __aBucle[188])
 __aG[188] := IIf((__aBucle[188] < 0) .Or. (__aNotBucle[188] <> .T.), Space(0), Chr(__aBucle[188]))

For __aBucle[187] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[187] := IIf((__aNotBucle[187] <> .T.), 255, __aBucle[187])
 __aG[187] := IIf((__aBucle[187] < 0) .Or. (__aNotBucle[187] <> .T.), Space(0), Chr(__aBucle[187]))

For __aBucle[186] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[186] := IIf((__aNotBucle[186] <> .T.), 255, __aBucle[186])
 __aG[186] := IIf((__aBucle[186] < 0) .Or. (__aNotBucle[186] <> .T.), Space(0), Chr(__aBucle[186]))

For __aBucle[185] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[185] := IIf((__aNotBucle[185] <> .T.), 255, __aBucle[185])
 __aG[185] := IIf((__aBucle[185] < 0) .Or. (__aNotBucle[185] <> .T.), Space(0), Chr(__aBucle[185]))

For __aBucle[184] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[184] := IIf((__aNotBucle[184] <> .T.), 255, __aBucle[184])
 __aG[184] := IIf((__aBucle[184] < 0) .Or. (__aNotBucle[184] <> .T.), Space(0), Chr(__aBucle[184]))

For __aBucle[183] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[183] := IIf((__aNotBucle[183] <> .T.), 255, __aBucle[183])
 __aG[183] := IIf((__aBucle[183] < 0) .Or. (__aNotBucle[183] <> .T.), Space(0), Chr(__aBucle[183]))

For __aBucle[182] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[182] := IIf((__aNotBucle[182] <> .T.), 255, __aBucle[182])
 __aG[182] := IIf((__aBucle[182] < 0) .Or. (__aNotBucle[182] <> .T.), Space(0), Chr(__aBucle[182]))

For __aBucle[181] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[181] := IIf((__aNotBucle[181] <> .T.), 255, __aBucle[181])
 __aG[181] := IIf((__aBucle[181] < 0) .Or. (__aNotBucle[181] <> .T.), Space(0), Chr(__aBucle[181]))

For __aBucle[180] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[180] := IIf((__aNotBucle[180] <> .T.), 255, __aBucle[180])
 __aG[180] := IIf((__aBucle[180] < 0) .Or. (__aNotBucle[180] <> .T.), Space(0), Chr(__aBucle[180]))

For __aBucle[179] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[179] := IIf((__aNotBucle[179] <> .T.), 255, __aBucle[179])
 __aG[179] := IIf((__aBucle[179] < 0) .Or. (__aNotBucle[179] <> .T.), Space(0), Chr(__aBucle[179]))

For __aBucle[178] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[178] := IIf((__aNotBucle[178] <> .T.), 255, __aBucle[178])
 __aG[178] := IIf((__aBucle[178] < 0) .Or. (__aNotBucle[178] <> .T.), Space(0), Chr(__aBucle[178]))

For __aBucle[177] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[177] := IIf((__aNotBucle[177] <> .T.), 255, __aBucle[177])
 __aG[177] := IIf((__aBucle[177] < 0) .Or. (__aNotBucle[177] <> .T.), Space(0), Chr(__aBucle[177]))

For __aBucle[176] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[176] := IIf((__aNotBucle[176] <> .T.), 255, __aBucle[176])
 __aG[176] := IIf((__aBucle[176] < 0) .Or. (__aNotBucle[176] <> .T.), Space(0), Chr(__aBucle[176]))

For __aBucle[175] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[175] := IIf((__aNotBucle[175] <> .T.), 255, __aBucle[175])
 __aG[175] := IIf((__aBucle[175] < 0) .Or. (__aNotBucle[175] <> .T.), Space(0), Chr(__aBucle[175]))

For __aBucle[174] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[174] := IIf((__aNotBucle[174] <> .T.), 255, __aBucle[174])
 __aG[174] := IIf((__aBucle[174] < 0) .Or. (__aNotBucle[174] <> .T.), Space(0), Chr(__aBucle[174]))

For __aBucle[173] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[173] := IIf((__aNotBucle[173] <> .T.), 255, __aBucle[173])
 __aG[173] := IIf((__aBucle[173] < 0) .Or. (__aNotBucle[173] <> .T.), Space(0), Chr(__aBucle[173]))

For __aBucle[172] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[172] := IIf((__aNotBucle[172] <> .T.), 255, __aBucle[172])
 __aG[172] := IIf((__aBucle[172] < 0) .Or. (__aNotBucle[172] <> .T.), Space(0), Chr(__aBucle[172]))

For __aBucle[171] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[171] := IIf((__aNotBucle[171] <> .T.), 255, __aBucle[171])
 __aG[171] := IIf((__aBucle[171] < 0) .Or. (__aNotBucle[171] <> .T.), Space(0), Chr(__aBucle[171]))

For __aBucle[170] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[170] := IIf((__aNotBucle[170] <> .T.), 255, __aBucle[170])
 __aG[170] := IIf((__aBucle[170] < 0) .Or. (__aNotBucle[170] <> .T.), Space(0), Chr(__aBucle[170]))

For __aBucle[169] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[169] := IIf((__aNotBucle[169] <> .T.), 255, __aBucle[169])
 __aG[169] := IIf((__aBucle[169] < 0) .Or. (__aNotBucle[169] <> .T.), Space(0), Chr(__aBucle[169]))

For __aBucle[168] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[168] := IIf((__aNotBucle[168] <> .T.), 255, __aBucle[168])
 __aG[168] := IIf((__aBucle[168] < 0) .Or. (__aNotBucle[168] <> .T.), Space(0), Chr(__aBucle[168]))

For __aBucle[167] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[167] := IIf((__aNotBucle[167] <> .T.), 255, __aBucle[167])
 __aG[167] := IIf((__aBucle[167] < 0) .Or. (__aNotBucle[167] <> .T.), Space(0), Chr(__aBucle[167]))

For __aBucle[166] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[166] := IIf((__aNotBucle[166] <> .T.), 255, __aBucle[166])
 __aG[166] := IIf((__aBucle[166] < 0) .Or. (__aNotBucle[166] <> .T.), Space(0), Chr(__aBucle[166]))

For __aBucle[165] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[165] := IIf((__aNotBucle[165] <> .T.), 255, __aBucle[165])
 __aG[165] := IIf((__aBucle[165] < 0) .Or. (__aNotBucle[165] <> .T.), Space(0), Chr(__aBucle[165]))

For __aBucle[164] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[164] := IIf((__aNotBucle[164] <> .T.), 255, __aBucle[164])
 __aG[164] := IIf((__aBucle[164] < 0) .Or. (__aNotBucle[164] <> .T.), Space(0), Chr(__aBucle[164]))

For __aBucle[163] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[163] := IIf((__aNotBucle[163] <> .T.), 255, __aBucle[163])
 __aG[163] := IIf((__aBucle[163] < 0) .Or. (__aNotBucle[163] <> .T.), Space(0), Chr(__aBucle[163]))

For __aBucle[162] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[162] := IIf((__aNotBucle[162] <> .T.), 255, __aBucle[162])
 __aG[162] := IIf((__aBucle[162] < 0) .Or. (__aNotBucle[162] <> .T.), Space(0), Chr(__aBucle[162]))

For __aBucle[161] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[161] := IIf((__aNotBucle[161] <> .T.), 255, __aBucle[161])
 __aG[161] := IIf((__aBucle[161] < 0) .Or. (__aNotBucle[161] <> .T.), Space(0), Chr(__aBucle[161]))

For __aBucle[160] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[160] := IIf((__aNotBucle[160] <> .T.), 255, __aBucle[160])
 __aG[160] := IIf((__aBucle[160] < 0) .Or. (__aNotBucle[160] <> .T.), Space(0), Chr(__aBucle[160]))

For __aBucle[159] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[159] := IIf((__aNotBucle[159] <> .T.), 255, __aBucle[159])
 __aG[159] := IIf((__aBucle[159] < 0) .Or. (__aNotBucle[159] <> .T.), Space(0), Chr(__aBucle[159]))

For __aBucle[158] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[158] := IIf((__aNotBucle[158] <> .T.), 255, __aBucle[158])
 __aG[158] := IIf((__aBucle[158] < 0) .Or. (__aNotBucle[158] <> .T.), Space(0), Chr(__aBucle[158]))

For __aBucle[157] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[157] := IIf((__aNotBucle[157] <> .T.), 255, __aBucle[157])
 __aG[157] := IIf((__aBucle[157] < 0) .Or. (__aNotBucle[157] <> .T.), Space(0), Chr(__aBucle[157]))

For __aBucle[156] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[156] := IIf((__aNotBucle[156] <> .T.), 255, __aBucle[156])
 __aG[156] := IIf((__aBucle[156] < 0) .Or. (__aNotBucle[156] <> .T.), Space(0), Chr(__aBucle[156]))

For __aBucle[155] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[155] := IIf((__aNotBucle[155] <> .T.), 255, __aBucle[155])
 __aG[155] := IIf((__aBucle[155] < 0) .Or. (__aNotBucle[155] <> .T.), Space(0), Chr(__aBucle[155]))

For __aBucle[154] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[154] := IIf((__aNotBucle[154] <> .T.), 255, __aBucle[154])
 __aG[154] := IIf((__aBucle[154] < 0) .Or. (__aNotBucle[154] <> .T.), Space(0), Chr(__aBucle[154]))

For __aBucle[153] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[153] := IIf((__aNotBucle[153] <> .T.), 255, __aBucle[153])
 __aG[153] := IIf((__aBucle[153] < 0) .Or. (__aNotBucle[153] <> .T.), Space(0), Chr(__aBucle[153]))

For __aBucle[152] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[152] := IIf((__aNotBucle[152] <> .T.), 255, __aBucle[152])
 __aG[152] := IIf((__aBucle[152] < 0) .Or. (__aNotBucle[152] <> .T.), Space(0), Chr(__aBucle[152]))

For __aBucle[151] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[151] := IIf((__aNotBucle[151] <> .T.), 255, __aBucle[151])
 __aG[151] := IIf((__aBucle[151] < 0) .Or. (__aNotBucle[151] <> .T.), Space(0), Chr(__aBucle[151]))

For __aBucle[150] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[150] := IIf((__aNotBucle[150] <> .T.), 255, __aBucle[150])
 __aG[150] := IIf((__aBucle[150] < 0) .Or. (__aNotBucle[150] <> .T.), Space(0), Chr(__aBucle[150]))

For __aBucle[149] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[149] := IIf((__aNotBucle[149] <> .T.), 255, __aBucle[149])
 __aG[149] := IIf((__aBucle[149] < 0) .Or. (__aNotBucle[149] <> .T.), Space(0), Chr(__aBucle[149]))

For __aBucle[148] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[148] := IIf((__aNotBucle[148] <> .T.), 255, __aBucle[148])
 __aG[148] := IIf((__aBucle[148] < 0) .Or. (__aNotBucle[148] <> .T.), Space(0), Chr(__aBucle[148]))

For __aBucle[147] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[147] := IIf((__aNotBucle[147] <> .T.), 255, __aBucle[147])
 __aG[147] := IIf((__aBucle[147] < 0) .Or. (__aNotBucle[147] <> .T.), Space(0), Chr(__aBucle[147]))

For __aBucle[146] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[146] := IIf((__aNotBucle[146] <> .T.), 255, __aBucle[146])
 __aG[146] := IIf((__aBucle[146] < 0) .Or. (__aNotBucle[146] <> .T.), Space(0), Chr(__aBucle[146]))

For __aBucle[145] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[145] := IIf((__aNotBucle[145] <> .T.), 255, __aBucle[145])
 __aG[145] := IIf((__aBucle[145] < 0) .Or. (__aNotBucle[145] <> .T.), Space(0), Chr(__aBucle[145]))

For __aBucle[144] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[144] := IIf((__aNotBucle[144] <> .T.), 255, __aBucle[144])
 __aG[144] := IIf((__aBucle[144] < 0) .Or. (__aNotBucle[144] <> .T.), Space(0), Chr(__aBucle[144]))

For __aBucle[143] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[143] := IIf((__aNotBucle[143] <> .T.), 255, __aBucle[143])
 __aG[143] := IIf((__aBucle[143] < 0) .Or. (__aNotBucle[143] <> .T.), Space(0), Chr(__aBucle[143]))

For __aBucle[142] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[142] := IIf((__aNotBucle[142] <> .T.), 255, __aBucle[142])
 __aG[142] := IIf((__aBucle[142] < 0) .Or. (__aNotBucle[142] <> .T.), Space(0), Chr(__aBucle[142]))

For __aBucle[141] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[141] := IIf((__aNotBucle[141] <> .T.), 255, __aBucle[141])
 __aG[141] := IIf((__aBucle[141] < 0) .Or. (__aNotBucle[141] <> .T.), Space(0), Chr(__aBucle[141]))

For __aBucle[140] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[140] := IIf((__aNotBucle[140] <> .T.), 255, __aBucle[140])
 __aG[140] := IIf((__aBucle[140] < 0) .Or. (__aNotBucle[140] <> .T.), Space(0), Chr(__aBucle[140]))

For __aBucle[139] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[139] := IIf((__aNotBucle[139] <> .T.), 255, __aBucle[139])
 __aG[139] := IIf((__aBucle[139] < 0) .Or. (__aNotBucle[139] <> .T.), Space(0), Chr(__aBucle[139]))

For __aBucle[138] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[138] := IIf((__aNotBucle[138] <> .T.), 255, __aBucle[138])
 __aG[138] := IIf((__aBucle[138] < 0) .Or. (__aNotBucle[138] <> .T.), Space(0), Chr(__aBucle[138]))

For __aBucle[137] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[137] := IIf((__aNotBucle[137] <> .T.), 255, __aBucle[137])
 __aG[137] := IIf((__aBucle[137] < 0) .Or. (__aNotBucle[137] <> .T.), Space(0), Chr(__aBucle[137]))

For __aBucle[136] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[136] := IIf((__aNotBucle[136] <> .T.), 255, __aBucle[136])
 __aG[136] := IIf((__aBucle[136] < 0) .Or. (__aNotBucle[136] <> .T.), Space(0), Chr(__aBucle[136]))

For __aBucle[135] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[135] := IIf((__aNotBucle[135] <> .T.), 255, __aBucle[135])
 __aG[135] := IIf((__aBucle[135] < 0) .Or. (__aNotBucle[135] <> .T.), Space(0), Chr(__aBucle[135]))

For __aBucle[134] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[134] := IIf((__aNotBucle[134] <> .T.), 255, __aBucle[134])
 __aG[134] := IIf((__aBucle[134] < 0) .Or. (__aNotBucle[134] <> .T.), Space(0), Chr(__aBucle[134]))

For __aBucle[133] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[133] := IIf((__aNotBucle[133] <> .T.), 255, __aBucle[133])
 __aG[133] := IIf((__aBucle[133] < 0) .Or. (__aNotBucle[133] <> .T.), Space(0), Chr(__aBucle[133]))

For __aBucle[132] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[132] := IIf((__aNotBucle[132] <> .T.), 255, __aBucle[132])
 __aG[132] := IIf((__aBucle[132] < 0) .Or. (__aNotBucle[132] <> .T.), Space(0), Chr(__aBucle[132]))

For __aBucle[131] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[131] := IIf((__aNotBucle[131] <> .T.), 255, __aBucle[131])
 __aG[131] := IIf((__aBucle[131] < 0) .Or. (__aNotBucle[131] <> .T.), Space(0), Chr(__aBucle[131]))

For __aBucle[130] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[130] := IIf((__aNotBucle[130] <> .T.), 255, __aBucle[130])
 __aG[130] := IIf((__aBucle[130] < 0) .Or. (__aNotBucle[130] <> .T.), Space(0), Chr(__aBucle[130]))

For __aBucle[129] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[129] := IIf((__aNotBucle[129] <> .T.), 255, __aBucle[129])
 __aG[129] := IIf((__aBucle[129] < 0) .Or. (__aNotBucle[129] <> .T.), Space(0), Chr(__aBucle[129]))

For __aBucle[128] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[128] := IIf((__aNotBucle[128] <> .T.), 255, __aBucle[128])
 __aG[128] := IIf((__aBucle[128] < 0) .Or. (__aNotBucle[128] <> .T.), Space(0), Chr(__aBucle[128]))

For __aBucle[127] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[127] := IIf((__aNotBucle[127] <> .T.), 255, __aBucle[127])
 __aG[127] := IIf((__aBucle[127] < 0) .Or. (__aNotBucle[127] <> .T.), Space(0), Chr(__aBucle[127]))

For __aBucle[126] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[126] := IIf((__aNotBucle[126] <> .T.), 255, __aBucle[126])
 __aG[126] := IIf((__aBucle[126] < 0) .Or. (__aNotBucle[126] <> .T.), Space(0), Chr(__aBucle[126]))

For __aBucle[125] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[125] := IIf((__aNotBucle[125] <> .T.), 255, __aBucle[125])
 __aG[125] := IIf((__aBucle[125] < 0) .Or. (__aNotBucle[125] <> .T.), Space(0), Chr(__aBucle[125]))

For __aBucle[124] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[124] := IIf((__aNotBucle[124] <> .T.), 255, __aBucle[124])
 __aG[124] := IIf((__aBucle[124] < 0) .Or. (__aNotBucle[124] <> .T.), Space(0), Chr(__aBucle[124]))

For __aBucle[123] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[123] := IIf((__aNotBucle[123] <> .T.), 255, __aBucle[123])
 __aG[123] := IIf((__aBucle[123] < 0) .Or. (__aNotBucle[123] <> .T.), Space(0), Chr(__aBucle[123]))

For __aBucle[122] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[122] := IIf((__aNotBucle[122] <> .T.), 255, __aBucle[122])
 __aG[122] := IIf((__aBucle[122] < 0) .Or. (__aNotBucle[122] <> .T.), Space(0), Chr(__aBucle[122]))

For __aBucle[121] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[121] := IIf((__aNotBucle[121] <> .T.), 255, __aBucle[121])
 __aG[121] := IIf((__aBucle[121] < 0) .Or. (__aNotBucle[121] <> .T.), Space(0), Chr(__aBucle[121]))

For __aBucle[120] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[120] := IIf((__aNotBucle[120] <> .T.), 255, __aBucle[120])
 __aG[120] := IIf((__aBucle[120] < 0) .Or. (__aNotBucle[120] <> .T.), Space(0), Chr(__aBucle[120]))

For __aBucle[119] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[119] := IIf((__aNotBucle[119] <> .T.), 255, __aBucle[119])
 __aG[119] := IIf((__aBucle[119] < 0) .Or. (__aNotBucle[119] <> .T.), Space(0), Chr(__aBucle[119]))

For __aBucle[118] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[118] := IIf((__aNotBucle[118] <> .T.), 255, __aBucle[118])
 __aG[118] := IIf((__aBucle[118] < 0) .Or. (__aNotBucle[118] <> .T.), Space(0), Chr(__aBucle[118]))

For __aBucle[117] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[117] := IIf((__aNotBucle[117] <> .T.), 255, __aBucle[117])
 __aG[117] := IIf((__aBucle[117] < 0) .Or. (__aNotBucle[117] <> .T.), Space(0), Chr(__aBucle[117]))

For __aBucle[116] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[116] := IIf((__aNotBucle[116] <> .T.), 255, __aBucle[116])
 __aG[116] := IIf((__aBucle[116] < 0) .Or. (__aNotBucle[116] <> .T.), Space(0), Chr(__aBucle[116]))

For __aBucle[115] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[115] := IIf((__aNotBucle[115] <> .T.), 255, __aBucle[115])
 __aG[115] := IIf((__aBucle[115] < 0) .Or. (__aNotBucle[115] <> .T.), Space(0), Chr(__aBucle[115]))

For __aBucle[114] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[114] := IIf((__aNotBucle[114] <> .T.), 255, __aBucle[114])
 __aG[114] := IIf((__aBucle[114] < 0) .Or. (__aNotBucle[114] <> .T.), Space(0), Chr(__aBucle[114]))

For __aBucle[113] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[113] := IIf((__aNotBucle[113] <> .T.), 255, __aBucle[113])
 __aG[113] := IIf((__aBucle[113] < 0) .Or. (__aNotBucle[113] <> .T.), Space(0), Chr(__aBucle[113]))

For __aBucle[112] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[112] := IIf((__aNotBucle[112] <> .T.), 255, __aBucle[112])
 __aG[112] := IIf((__aBucle[112] < 0) .Or. (__aNotBucle[112] <> .T.), Space(0), Chr(__aBucle[112]))

For __aBucle[111] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[111] := IIf((__aNotBucle[111] <> .T.), 255, __aBucle[111])
 __aG[111] := IIf((__aBucle[111] < 0) .Or. (__aNotBucle[111] <> .T.), Space(0), Chr(__aBucle[111]))

For __aBucle[110] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[110] := IIf((__aNotBucle[110] <> .T.), 255, __aBucle[110])
 __aG[110] := IIf((__aBucle[110] < 0) .Or. (__aNotBucle[110] <> .T.), Space(0), Chr(__aBucle[110]))

For __aBucle[109] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[109] := IIf((__aNotBucle[109] <> .T.), 255, __aBucle[109])
 __aG[109] := IIf((__aBucle[109] < 0) .Or. (__aNotBucle[109] <> .T.), Space(0), Chr(__aBucle[109]))

For __aBucle[108] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[108] := IIf((__aNotBucle[108] <> .T.), 255, __aBucle[108])
 __aG[108] := IIf((__aBucle[108] < 0) .Or. (__aNotBucle[108] <> .T.), Space(0), Chr(__aBucle[108]))

For __aBucle[107] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[107] := IIf((__aNotBucle[107] <> .T.), 255, __aBucle[107])
 __aG[107] := IIf((__aBucle[107] < 0) .Or. (__aNotBucle[107] <> .T.), Space(0), Chr(__aBucle[107]))

For __aBucle[106] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[106] := IIf((__aNotBucle[106] <> .T.), 255, __aBucle[106])
 __aG[106] := IIf((__aBucle[106] < 0) .Or. (__aNotBucle[106] <> .T.), Space(0), Chr(__aBucle[106]))

For __aBucle[105] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[105] := IIf((__aNotBucle[105] <> .T.), 255, __aBucle[105])
 __aG[105] := IIf((__aBucle[105] < 0) .Or. (__aNotBucle[105] <> .T.), Space(0), Chr(__aBucle[105]))

For __aBucle[104] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[104] := IIf((__aNotBucle[104] <> .T.), 255, __aBucle[104])
 __aG[104] := IIf((__aBucle[104] < 0) .Or. (__aNotBucle[104] <> .T.), Space(0), Chr(__aBucle[104]))

For __aBucle[103] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[103] := IIf((__aNotBucle[103] <> .T.), 255, __aBucle[103])
 __aG[103] := IIf((__aBucle[103] < 0) .Or. (__aNotBucle[103] <> .T.), Space(0), Chr(__aBucle[103]))

For __aBucle[102] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[102] := IIf((__aNotBucle[102] <> .T.), 255, __aBucle[102])
 __aG[102] := IIf((__aBucle[102] < 0) .Or. (__aNotBucle[102] <> .T.), Space(0), Chr(__aBucle[102]))

For __aBucle[101] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[101] := IIf((__aNotBucle[101] <> .T.), 255, __aBucle[101])
 __aG[101] := IIf((__aBucle[101] < 0) .Or. (__aNotBucle[101] <> .T.), Space(0), Chr(__aBucle[101]))

For __aBucle[100] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[100] := IIf((__aNotBucle[100] <> .T.), 255, __aBucle[100])
 __aG[100] := IIf((__aBucle[100] < 0) .Or. (__aNotBucle[100] <> .T.), Space(0), Chr(__aBucle[100]))

For __aBucle[099] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[099] := IIf((__aNotBucle[099] <> .T.), 255, __aBucle[099])
 __aG[099] := IIf((__aBucle[099] < 0) .Or. (__aNotBucle[099] <> .T.), Space(0), Chr(__aBucle[099]))

For __aBucle[098] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[098] := IIf((__aNotBucle[098] <> .T.), 255, __aBucle[098])
 __aG[098] := IIf((__aBucle[098] < 0) .Or. (__aNotBucle[098] <> .T.), Space(0), Chr(__aBucle[098]))

For __aBucle[097] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[097] := IIf((__aNotBucle[097] <> .T.), 255, __aBucle[097])
 __aG[097] := IIf((__aBucle[097] < 0) .Or. (__aNotBucle[097] <> .T.), Space(0), Chr(__aBucle[097]))

For __aBucle[096] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[096] := IIf((__aNotBucle[096] <> .T.), 255, __aBucle[096])
 __aG[096] := IIf((__aBucle[096] < 0) .Or. (__aNotBucle[096] <> .T.), Space(0), Chr(__aBucle[096]))

For __aBucle[095] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[095] := IIf((__aNotBucle[095] <> .T.), 255, __aBucle[095])
 __aG[095] := IIf((__aBucle[095] < 0) .Or. (__aNotBucle[095] <> .T.), Space(0), Chr(__aBucle[095]))

For __aBucle[094] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[094] := IIf((__aNotBucle[094] <> .T.), 255, __aBucle[094])
 __aG[094] := IIf((__aBucle[094] < 0) .Or. (__aNotBucle[094] <> .T.), Space(0), Chr(__aBucle[094]))

For __aBucle[093] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[093] := IIf((__aNotBucle[093] <> .T.), 255, __aBucle[093])
 __aG[093] := IIf((__aBucle[093] < 0) .Or. (__aNotBucle[093] <> .T.), Space(0), Chr(__aBucle[093]))

For __aBucle[092] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[092] := IIf((__aNotBucle[092] <> .T.), 255, __aBucle[092])
 __aG[092] := IIf((__aBucle[092] < 0) .Or. (__aNotBucle[092] <> .T.), Space(0), Chr(__aBucle[092]))

For __aBucle[091] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[091] := IIf((__aNotBucle[091] <> .T.), 255, __aBucle[091])
 __aG[091] := IIf((__aBucle[091] < 0) .Or. (__aNotBucle[091] <> .T.), Space(0), Chr(__aBucle[091]))

For __aBucle[090] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[090] := IIf((__aNotBucle[090] <> .T.), 255, __aBucle[090])
 __aG[090] := IIf((__aBucle[090] < 0) .Or. (__aNotBucle[090] <> .T.), Space(0), Chr(__aBucle[090]))

For __aBucle[089] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[089] := IIf((__aNotBucle[089] <> .T.), 255, __aBucle[089])
 __aG[089] := IIf((__aBucle[089] < 0) .Or. (__aNotBucle[089] <> .T.), Space(0), Chr(__aBucle[089]))

For __aBucle[088] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[088] := IIf((__aNotBucle[088] <> .T.), 255, __aBucle[088])
 __aG[088] := IIf((__aBucle[088] < 0) .Or. (__aNotBucle[088] <> .T.), Space(0), Chr(__aBucle[088]))

For __aBucle[087] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[087] := IIf((__aNotBucle[087] <> .T.), 255, __aBucle[087])
 __aG[087] := IIf((__aBucle[087] < 0) .Or. (__aNotBucle[087] <> .T.), Space(0), Chr(__aBucle[087]))

For __aBucle[086] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[086] := IIf((__aNotBucle[086] <> .T.), 255, __aBucle[086])
 __aG[086] := IIf((__aBucle[086] < 0) .Or. (__aNotBucle[086] <> .T.), Space(0), Chr(__aBucle[086]))

For __aBucle[085] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[085] := IIf((__aNotBucle[085] <> .T.), 255, __aBucle[085])
 __aG[085] := IIf((__aBucle[085] < 0) .Or. (__aNotBucle[085] <> .T.), Space(0), Chr(__aBucle[085]))

For __aBucle[084] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[084] := IIf((__aNotBucle[084] <> .T.), 255, __aBucle[084])
 __aG[084] := IIf((__aBucle[084] < 0) .Or. (__aNotBucle[084] <> .T.), Space(0), Chr(__aBucle[084]))

For __aBucle[083] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[083] := IIf((__aNotBucle[083] <> .T.), 255, __aBucle[083])
 __aG[083] := IIf((__aBucle[083] < 0) .Or. (__aNotBucle[083] <> .T.), Space(0), Chr(__aBucle[083]))

For __aBucle[082] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[082] := IIf((__aNotBucle[082] <> .T.), 255, __aBucle[082])
 __aG[082] := IIf((__aBucle[082] < 0) .Or. (__aNotBucle[082] <> .T.), Space(0), Chr(__aBucle[082]))

For __aBucle[081] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[081] := IIf((__aNotBucle[081] <> .T.), 255, __aBucle[081])
 __aG[081] := IIf((__aBucle[081] < 0) .Or. (__aNotBucle[081] <> .T.), Space(0), Chr(__aBucle[081]))

For __aBucle[080] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[080] := IIf((__aNotBucle[080] <> .T.), 255, __aBucle[080])
 __aG[080] := IIf((__aBucle[080] < 0) .Or. (__aNotBucle[080] <> .T.), Space(0), Chr(__aBucle[080]))

For __aBucle[079] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[079] := IIf((__aNotBucle[079] <> .T.), 255, __aBucle[079])
 __aG[079] := IIf((__aBucle[079] < 0) .Or. (__aNotBucle[079] <> .T.), Space(0), Chr(__aBucle[079]))

For __aBucle[078] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[078] := IIf((__aNotBucle[078] <> .T.), 255, __aBucle[078])
 __aG[078] := IIf((__aBucle[078] < 0) .Or. (__aNotBucle[078] <> .T.), Space(0), Chr(__aBucle[078]))

For __aBucle[077] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[077] := IIf((__aNotBucle[077] <> .T.), 255, __aBucle[077])
 __aG[077] := IIf((__aBucle[077] < 0) .Or. (__aNotBucle[077] <> .T.), Space(0), Chr(__aBucle[077]))

For __aBucle[076] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[076] := IIf((__aNotBucle[076] <> .T.), 255, __aBucle[076])
 __aG[076] := IIf((__aBucle[076] < 0) .Or. (__aNotBucle[076] <> .T.), Space(0), Chr(__aBucle[076]))

For __aBucle[075] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[075] := IIf((__aNotBucle[075] <> .T.), 255, __aBucle[075])
 __aG[075] := IIf((__aBucle[075] < 0) .Or. (__aNotBucle[075] <> .T.), Space(0), Chr(__aBucle[075]))

For __aBucle[074] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[074] := IIf((__aNotBucle[074] <> .T.), 255, __aBucle[074])
 __aG[074] := IIf((__aBucle[074] < 0) .Or. (__aNotBucle[074] <> .T.), Space(0), Chr(__aBucle[074]))

For __aBucle[073] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[073] := IIf((__aNotBucle[073] <> .T.), 255, __aBucle[073])
 __aG[073] := IIf((__aBucle[073] < 0) .Or. (__aNotBucle[073] <> .T.), Space(0), Chr(__aBucle[073]))

For __aBucle[072] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[072] := IIf((__aNotBucle[072] <> .T.), 255, __aBucle[072])
 __aG[072] := IIf((__aBucle[072] < 0) .Or. (__aNotBucle[072] <> .T.), Space(0), Chr(__aBucle[072]))

For __aBucle[071] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[071] := IIf((__aNotBucle[071] <> .T.), 255, __aBucle[071])
 __aG[071] := IIf((__aBucle[071] < 0) .Or. (__aNotBucle[071] <> .T.), Space(0), Chr(__aBucle[071]))

For __aBucle[070] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[070] := IIf((__aNotBucle[070] <> .T.), 255, __aBucle[070])
 __aG[070] := IIf((__aBucle[070] < 0) .Or. (__aNotBucle[070] <> .T.), Space(0), Chr(__aBucle[070]))

For __aBucle[069] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[069] := IIf((__aNotBucle[069] <> .T.), 255, __aBucle[069])
 __aG[069] := IIf((__aBucle[069] < 0) .Or. (__aNotBucle[069] <> .T.), Space(0), Chr(__aBucle[069]))

For __aBucle[068] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[068] := IIf((__aNotBucle[068] <> .T.), 255, __aBucle[068])
 __aG[068] := IIf((__aBucle[068] < 0) .Or. (__aNotBucle[068] <> .T.), Space(0), Chr(__aBucle[068]))

For __aBucle[067] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[067] := IIf((__aNotBucle[067] <> .T.), 255, __aBucle[067])
 __aG[067] := IIf((__aBucle[067] < 0) .Or. (__aNotBucle[067] <> .T.), Space(0), Chr(__aBucle[067]))

For __aBucle[066] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[066] := IIf((__aNotBucle[066] <> .T.), 255, __aBucle[066])
 __aG[066] := IIf((__aBucle[066] < 0) .Or. (__aNotBucle[066] <> .T.), Space(0), Chr(__aBucle[066]))

For __aBucle[065] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[065] := IIf((__aNotBucle[065] <> .T.), 255, __aBucle[065])
 __aG[065] := IIf((__aBucle[065] < 0) .Or. (__aNotBucle[065] <> .T.), Space(0), Chr(__aBucle[065]))

For __aBucle[064] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[064] := IIf((__aNotBucle[064] <> .T.), 255, __aBucle[064])
 __aG[064] := IIf((__aBucle[064] < 0) .Or. (__aNotBucle[064] <> .T.), Space(0), Chr(__aBucle[064]))

For __aBucle[063] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[063] := IIf((__aNotBucle[063] <> .T.), 255, __aBucle[063])
 __aG[063] := IIf((__aBucle[063] < 0) .Or. (__aNotBucle[063] <> .T.), Space(0), Chr(__aBucle[063]))

For __aBucle[062] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[062] := IIf((__aNotBucle[062] <> .T.), 255, __aBucle[062])
 __aG[062] := IIf((__aBucle[062] < 0) .Or. (__aNotBucle[062] <> .T.), Space(0), Chr(__aBucle[062]))

For __aBucle[061] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[061] := IIf((__aNotBucle[061] <> .T.), 255, __aBucle[061])
 __aG[061] := IIf((__aBucle[061] < 0) .Or. (__aNotBucle[061] <> .T.), Space(0), Chr(__aBucle[061]))

For __aBucle[060] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[060] := IIf((__aNotBucle[060] <> .T.), 255, __aBucle[060])
 __aG[060] := IIf((__aBucle[060] < 0) .Or. (__aNotBucle[060] <> .T.), Space(0), Chr(__aBucle[060]))

For __aBucle[059] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[059] := IIf((__aNotBucle[059] <> .T.), 255, __aBucle[059])
 __aG[059] := IIf((__aBucle[059] < 0) .Or. (__aNotBucle[059] <> .T.), Space(0), Chr(__aBucle[059]))

For __aBucle[058] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[058] := IIf((__aNotBucle[058] <> .T.), 255, __aBucle[058])
 __aG[058] := IIf((__aBucle[058] < 0) .Or. (__aNotBucle[058] <> .T.), Space(0), Chr(__aBucle[058]))

For __aBucle[057] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[057] := IIf((__aNotBucle[057] <> .T.), 255, __aBucle[057])
 __aG[057] := IIf((__aBucle[057] < 0) .Or. (__aNotBucle[057] <> .T.), Space(0), Chr(__aBucle[057]))

For __aBucle[056] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[056] := IIf((__aNotBucle[056] <> .T.), 255, __aBucle[056])
 __aG[056] := IIf((__aBucle[056] < 0) .Or. (__aNotBucle[056] <> .T.), Space(0), Chr(__aBucle[056]))

For __aBucle[055] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[055] := IIf((__aNotBucle[055] <> .T.), 255, __aBucle[055])
 __aG[055] := IIf((__aBucle[055] < 0) .Or. (__aNotBucle[055] <> .T.), Space(0), Chr(__aBucle[055]))

For __aBucle[054] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[054] := IIf((__aNotBucle[054] <> .T.), 255, __aBucle[054])
 __aG[054] := IIf((__aBucle[054] < 0) .Or. (__aNotBucle[054] <> .T.), Space(0), Chr(__aBucle[054]))

For __aBucle[053] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[053] := IIf((__aNotBucle[053] <> .T.), 255, __aBucle[053])
 __aG[053] := IIf((__aBucle[053] < 0) .Or. (__aNotBucle[053] <> .T.), Space(0), Chr(__aBucle[053]))

For __aBucle[052] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[052] := IIf((__aNotBucle[052] <> .T.), 255, __aBucle[052])
 __aG[052] := IIf((__aBucle[052] < 0) .Or. (__aNotBucle[052] <> .T.), Space(0), Chr(__aBucle[052]))

For __aBucle[051] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[051] := IIf((__aNotBucle[051] <> .T.), 255, __aBucle[051])
 __aG[051] := IIf((__aBucle[051] < 0) .Or. (__aNotBucle[051] <> .T.), Space(0), Chr(__aBucle[051]))

For __aBucle[050] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[050] := IIf((__aNotBucle[050] <> .T.), 255, __aBucle[050])
 __aG[050] := IIf((__aBucle[050] < 0) .Or. (__aNotBucle[050] <> .T.), Space(0), Chr(__aBucle[050]))

For __aBucle[049] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[049] := IIf((__aNotBucle[049] <> .T.), 255, __aBucle[049])
 __aG[049] := IIf((__aBucle[049] < 0) .Or. (__aNotBucle[049] <> .T.), Space(0), Chr(__aBucle[049]))

For __aBucle[048] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[048] := IIf((__aNotBucle[048] <> .T.), 255, __aBucle[048])
 __aG[048] := IIf((__aBucle[048] < 0) .Or. (__aNotBucle[048] <> .T.), Space(0), Chr(__aBucle[048]))

For __aBucle[047] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[047] := IIf((__aNotBucle[047] <> .T.), 255, __aBucle[047])
 __aG[047] := IIf((__aBucle[047] < 0) .Or. (__aNotBucle[047] <> .T.), Space(0), Chr(__aBucle[047]))

For __aBucle[046] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[046] := IIf((__aNotBucle[046] <> .T.), 255, __aBucle[046])
 __aG[046] := IIf((__aBucle[046] < 0) .Or. (__aNotBucle[046] <> .T.), Space(0), Chr(__aBucle[046]))

For __aBucle[045] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[045] := IIf((__aNotBucle[045] <> .T.), 255, __aBucle[045])
 __aG[045] := IIf((__aBucle[045] < 0) .Or. (__aNotBucle[045] <> .T.), Space(0), Chr(__aBucle[045]))

For __aBucle[044] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[044] := IIf((__aNotBucle[044] <> .T.), 255, __aBucle[044])
 __aG[044] := IIf((__aBucle[044] < 0) .Or. (__aNotBucle[044] <> .T.), Space(0), Chr(__aBucle[044]))

For __aBucle[043] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[043] := IIf((__aNotBucle[043] <> .T.), 255, __aBucle[043])
 __aG[043] := IIf((__aBucle[043] < 0) .Or. (__aNotBucle[043] <> .T.), Space(0), Chr(__aBucle[043]))

For __aBucle[042] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[042] := IIf((__aNotBucle[042] <> .T.), 255, __aBucle[042])
 __aG[042] := IIf((__aBucle[042] < 0) .Or. (__aNotBucle[042] <> .T.), Space(0), Chr(__aBucle[042]))

For __aBucle[041] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[041] := IIf((__aNotBucle[041] <> .T.), 255, __aBucle[041])
 __aG[041] := IIf((__aBucle[041] < 0) .Or. (__aNotBucle[041] <> .T.), Space(0), Chr(__aBucle[041]))

For __aBucle[040] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[040] := IIf((__aNotBucle[040] <> .T.), 255, __aBucle[040])
 __aG[040] := IIf((__aBucle[040] < 0) .Or. (__aNotBucle[040] <> .T.), Space(0), Chr(__aBucle[040]))

For __aBucle[039] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[039] := IIf((__aNotBucle[039] <> .T.), 255, __aBucle[039])
 __aG[039] := IIf((__aBucle[039] < 0) .Or. (__aNotBucle[039] <> .T.), Space(0), Chr(__aBucle[039]))

For __aBucle[038] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[038] := IIf((__aNotBucle[038] <> .T.), 255, __aBucle[038])
 __aG[038] := IIf((__aBucle[038] < 0) .Or. (__aNotBucle[038] <> .T.), Space(0), Chr(__aBucle[038]))

For __aBucle[037] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[037] := IIf((__aNotBucle[037] <> .T.), 255, __aBucle[037])
 __aG[037] := IIf((__aBucle[037] < 0) .Or. (__aNotBucle[037] <> .T.), Space(0), Chr(__aBucle[037]))

For __aBucle[036] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[036] := IIf((__aNotBucle[036] <> .T.), 255, __aBucle[036])
 __aG[036] := IIf((__aBucle[036] < 0) .Or. (__aNotBucle[036] <> .T.), Space(0), Chr(__aBucle[036]))

For __aBucle[035] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[035] := IIf((__aNotBucle[035] <> .T.), 255, __aBucle[035])
 __aG[035] := IIf((__aBucle[035] < 0) .Or. (__aNotBucle[035] <> .T.), Space(0), Chr(__aBucle[035]))

For __aBucle[034] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[034] := IIf((__aNotBucle[034] <> .T.), 255, __aBucle[034])
 __aG[034] := IIf((__aBucle[034] < 0) .Or. (__aNotBucle[034] <> .T.), Space(0), Chr(__aBucle[034]))

For __aBucle[033] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[033] := IIf((__aNotBucle[033] <> .T.), 255, __aBucle[033])
 __aG[033] := IIf((__aBucle[033] < 0) .Or. (__aNotBucle[033] <> .T.), Space(0), Chr(__aBucle[033]))

For __aBucle[032] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[032] := IIf((__aNotBucle[032] <> .T.), 255, __aBucle[032])
 __aG[032] := IIf((__aBucle[032] < 0) .Or. (__aNotBucle[032] <> .T.), Space(0), Chr(__aBucle[032]))

For __aBucle[031] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[031] := IIf((__aNotBucle[031] <> .T.), 255, __aBucle[031])
 __aG[031] := IIf((__aBucle[031] < 0) .Or. (__aNotBucle[031] <> .T.), Space(0), Chr(__aBucle[031]))

For __aBucle[030] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[030] := IIf((__aNotBucle[030] <> .T.), 255, __aBucle[030])
 __aG[030] := IIf((__aBucle[030] < 0) .Or. (__aNotBucle[030] <> .T.), Space(0), Chr(__aBucle[030]))

For __aBucle[029] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[029] := IIf((__aNotBucle[029] <> .T.), 255, __aBucle[029])
 __aG[029] := IIf((__aBucle[029] < 0) .Or. (__aNotBucle[029] <> .T.), Space(0), Chr(__aBucle[029]))

For __aBucle[028] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[028] := IIf((__aNotBucle[028] <> .T.), 255, __aBucle[028])
 __aG[028] := IIf((__aBucle[028] < 0) .Or. (__aNotBucle[028] <> .T.), Space(0), Chr(__aBucle[028]))

For __aBucle[027] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[027] := IIf((__aNotBucle[027] <> .T.), 255, __aBucle[027])
 __aG[027] := IIf((__aBucle[027] < 0) .Or. (__aNotBucle[027] <> .T.), Space(0), Chr(__aBucle[027]))

For __aBucle[026] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[026] := IIf((__aNotBucle[026] <> .T.), 255, __aBucle[026])
 __aG[026] := IIf((__aBucle[026] < 0) .Or. (__aNotBucle[026] <> .T.), Space(0), Chr(__aBucle[026]))

For __aBucle[025] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[025] := IIf((__aNotBucle[025] <> .T.), 255, __aBucle[025])
 __aG[025] := IIf((__aBucle[025] < 0) .Or. (__aNotBucle[025] <> .T.), Space(0), Chr(__aBucle[025]))

For __aBucle[024] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[024] := IIf((__aNotBucle[024] <> .T.), 255, __aBucle[024])
 __aG[024] := IIf((__aBucle[024] < 0) .Or. (__aNotBucle[024] <> .T.), Space(0), Chr(__aBucle[024]))

For __aBucle[023] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[023] := IIf((__aNotBucle[023] <> .T.), 255, __aBucle[023])
 __aG[023] := IIf((__aBucle[023] < 0) .Or. (__aNotBucle[023] <> .T.), Space(0), Chr(__aBucle[023]))

For __aBucle[022] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[022] := IIf((__aNotBucle[022] <> .T.), 255, __aBucle[022])
 __aG[022] := IIf((__aBucle[022] < 0) .Or. (__aNotBucle[022] <> .T.), Space(0), Chr(__aBucle[022]))

For __aBucle[021] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[021] := IIf((__aNotBucle[021] <> .T.), 255, __aBucle[021])
 __aG[021] := IIf((__aBucle[021] < 0) .Or. (__aNotBucle[021] <> .T.), Space(0), Chr(__aBucle[021]))

For __aBucle[020] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[020] := IIf((__aNotBucle[020] <> .T.), 255, __aBucle[020])
 __aG[020] := IIf((__aBucle[020] < 0) .Or. (__aNotBucle[020] <> .T.), Space(0), Chr(__aBucle[020]))

For __aBucle[019] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[019] := IIf((__aNotBucle[019] <> .T.), 255, __aBucle[019])
 __aG[019] := IIf((__aBucle[019] < 0) .Or. (__aNotBucle[019] <> .T.), Space(0), Chr(__aBucle[019]))

For __aBucle[018] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[018] := IIf((__aNotBucle[018] <> .T.), 255, __aBucle[018])
 __aG[018] := IIf((__aBucle[018] < 0) .Or. (__aNotBucle[018] <> .T.), Space(0), Chr(__aBucle[018]))

For __aBucle[017] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[017] := IIf((__aNotBucle[017] <> .T.), 255, __aBucle[017])
 __aG[017] := IIf((__aBucle[017] < 0) .Or. (__aNotBucle[017] <> .T.), Space(0), Chr(__aBucle[017]))

For __aBucle[016] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[016] := IIf((__aNotBucle[016] <> .T.), 255, __aBucle[016])
 __aG[016] := IIf((__aBucle[016] < 0) .Or. (__aNotBucle[016] <> .T.), Space(0), Chr(__aBucle[016]))

For __aBucle[015] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[015] := IIf((__aNotBucle[015] <> .T.), 255, __aBucle[015])
 __aG[015] := IIf((__aBucle[015] < 0) .Or. (__aNotBucle[015] <> .T.), Space(0), Chr(__aBucle[015]))

For __aBucle[014] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[014] := IIf((__aNotBucle[014] <> .T.), 255, __aBucle[014])
 __aG[014] := IIf((__aBucle[014] < 0) .Or. (__aNotBucle[014] <> .T.), Space(0), Chr(__aBucle[014]))

For __aBucle[013] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[013] := IIf((__aNotBucle[013] <> .T.), 255, __aBucle[013])
 __aG[013] := IIf((__aBucle[013] < 0) .Or. (__aNotBucle[013] <> .T.), Space(0), Chr(__aBucle[013]))

For __aBucle[012] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[012] := IIf((__aNotBucle[012] <> .T.), 255, __aBucle[012])
 __aG[012] := IIf((__aBucle[012] < 0) .Or. (__aNotBucle[012] <> .T.), Space(0), Chr(__aBucle[012]))

For __aBucle[011] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[011] := IIf((__aNotBucle[011] <> .T.), 255, __aBucle[011])
 __aG[011] := IIf((__aBucle[011] < 0) .Or. (__aNotBucle[011] <> .T.), Space(0), Chr(__aBucle[011]))

For __aBucle[010] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[010] := IIf((__aNotBucle[010] <> .T.), 255, __aBucle[010])
 __aG[010] := IIf((__aBucle[010] < 0) .Or. (__aNotBucle[010] <> .T.), Space(0), Chr(__aBucle[010]))

For __aBucle[009] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[009] := IIf((__aNotBucle[009] <> .T.), 255, __aBucle[009])
 __aG[009] := IIf((__aBucle[009] < 0) .Or. (__aNotBucle[009] <> .T.), Space(0), Chr(__aBucle[009]))

For __aBucle[008] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[008] := IIf((__aNotBucle[008] <> .T.), 255, __aBucle[008])
 __aG[008] := IIf((__aBucle[008] < 0) .Or. (__aNotBucle[008] <> .T.), Space(0), Chr(__aBucle[008]))

For __aBucle[007] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[007] := IIf((__aNotBucle[007] <> .T.), 255, __aBucle[007])
 __aG[007] := IIf((__aBucle[007] < 0) .Or. (__aNotBucle[007] <> .T.), Space(0), Chr(__aBucle[007]))

For __aBucle[006] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[006] := IIf((__aNotBucle[006] <> .T.), 255, __aBucle[006])
 __aG[006] := IIf((__aBucle[006] < 0) .Or. (__aNotBucle[006] <> .T.), Space(0), Chr(__aBucle[006]))

For __aBucle[005] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[005] := IIf((__aNotBucle[005] <> .T.), 255, __aBucle[005])
 __aG[005] := IIf((__aBucle[005] < 0) .Or. (__aNotBucle[005] <> .T.), Space(0), Chr(__aBucle[005]))

For __aBucle[004] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[004] := IIf((__aNotBucle[004] <> .T.), 255, __aBucle[004])
 __aG[004] := IIf((__aBucle[004] < 0) .Or. (__aNotBucle[004] <> .T.), Space(0), Chr(__aBucle[004]))

For __aBucle[003] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[003] := IIf((__aNotBucle[003] <> .T.), 255, __aBucle[003])
 __aG[003] := IIf((__aBucle[003] < 0) .Or. (__aNotBucle[003] <> .T.), Space(0), Chr(__aBucle[003]))

For __aBucle[002] = (-1) To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aBucle[002] := IIf((__aNotBucle[002] <> .T.), 255, __aBucle[002])
 __aG[002] := IIf((__aBucle[002] < 0) .Or. (__aNotBucle[002] <> .T.), Space(0), Chr(__aBucle[002]))

For __aBucle[001] = 0 To 255 Step 1
 __XGenStr[2] := IIf((__aBucle[__nLen] < 0), 0, __aBucle[__nLen])
 __aG[001] := Chr(__aBucle[001])
 __aTemp[16] := (__aG[256] + __aG[255] + __aG[254] + __aG[253] + __aG[252] + __aG[251] + __aG[250] + __aG[249] + __aG[248] + __aG[247] + __aG[246] + __aG[245] + __aG[244] + __aG[243] + __aG[242] + __aG[241])
 __aTemp[15] := (__aG[240] + __aG[239] + __aG[238] + __aG[237] + __aG[236] + __aG[235] + __aG[234] + __aG[233] + __aG[232] + __aG[231] + __aG[230] + __aG[229] + __aG[228] + __aG[227] + __aG[226] + __aG[225])
 __aTemp[14] := (__aG[224] + __aG[223] + __aG[222] + __aG[221] + __aG[220] + __aG[219] + __aG[218] + __aG[217] + __aG[216] + __aG[215] + __aG[214] + __aG[213] + __aG[212] + __aG[211] + __aG[210] + __aG[209])
 __aTemp[13] := (__aG[208] + __aG[207] + __aG[206] + __aG[205] + __aG[204] + __aG[203] + __aG[202] + __aG[201] + __aG[200] + __aG[199] + __aG[198] + __aG[197] + __aG[196] + __aG[195] + __aG[194] + __aG[193])
 __aTemp[12] := (__aG[192] + __aG[191] + __aG[190] + __aG[189] + __aG[188] + __aG[187] + __aG[186] + __aG[185] + __aG[184] + __aG[183] + __aG[182] + __aG[181] + __aG[180] + __aG[179] + __aG[178] + __aG[177])
 __aTemp[11] := (__aG[176] + __aG[175] + __aG[174] + __aG[173] + __aG[172] + __aG[171] + __aG[170] + __aG[169] + __aG[168] + __aG[167] + __aG[166] + __aG[165] + __aG[164] + __aG[163] + __aG[162] + __aG[161])
 __aTemp[10] := (__aG[160] + __aG[159] + __aG[158] + __aG[157] + __aG[156] + __aG[155] + __aG[154] + __aG[153] + __aG[152] + __aG[151] + __aG[150] + __aG[149] + __aG[148] + __aG[147] + __aG[146] + __aG[145])
 __aTemp[09] := (__aG[144] + __aG[143] + __aG[142] + __aG[141] + __aG[140] + __aG[139] + __aG[138] + __aG[137] + __aG[136] + __aG[135] + __aG[134] + __aG[133] + __aG[132] + __aG[131] + __aG[130] + __aG[129])
 __aTemp[08] := (__aG[128] + __aG[127] + __aG[126] + __aG[125] + __aG[124] + __aG[123] + __aG[122] + __aG[121] + __aG[120] + __aG[119] + __aG[118] + __aG[117] + __aG[116] + __aG[115] + __aG[114] + __aG[113])
 __aTemp[07] := (__aG[112] + __aG[111] + __aG[110] + __aG[109] + __aG[108] + __aG[107] + __aG[106] + __aG[105] + __aG[104] + __aG[103] + __aG[102] + __aG[101] + __aG[100] + __aG[099] + __aG[098] + __aG[097])
 __aTemp[06] := (__aG[096] + __aG[095] + __aG[094] + __aG[093] + __aG[092] + __aG[091] + __aG[090] + __aG[089] + __aG[088] + __aG[087] + __aG[086] + __aG[085] + __aG[084] + __aG[083] + __aG[082] + __aG[081])
 __aTemp[05] := (__aG[080] + __aG[079] + __aG[078] + __aG[077] + __aG[076] + __aG[075] + __aG[074] + __aG[073] + __aG[072] + __aG[071] + __aG[070] + __aG[069] + __aG[068] + __aG[067] + __aG[066] + __aG[065])
 __aTemp[04] := (__aG[064] + __aG[063] + __aG[062] + __aG[061] + __aG[060] + __aG[059] + __aG[058] + __aG[057] + __aG[056] + __aG[055] + __aG[054] + __aG[053] + __aG[052] + __aG[051] + __aG[050] + __aG[049])
 __aTemp[03] := (__aG[048] + __aG[047] + __aG[046] + __aG[045] + __aG[044] + __aG[043] + __aG[042] + __aG[041] + __aG[040] + __aG[039] + __aG[038] + __aG[037] + __aG[036] + __aG[035] + __aG[034] + __aG[033])
 __aTemp[02] := (__aG[032] + __aG[031] + __aG[030] + __aG[029] + __aG[028] + __aG[027] + __aG[026] + __aG[025] + __aG[024] + __aG[023] + __aG[022] + __aG[021] + __aG[020] + __aG[019] + __aG[018] + __aG[017])
 __aTemp[01] := (__aG[016] + __aG[015] + __aG[014] + __aG[013] + __aG[012] + __aG[011] + __aG[010] + __aG[009] + __aG[008] + __aG[007] + __aG[006] + __aG[005] + __aG[004] + __aG[003] + __aG[002] + __aG[001])
 __XGenStr[1] := (__aTemp[16] + __aTemp[15] + __aTemp[14] + __aTemp[13] + __aTemp[12] + __aTemp[11] + __aTemp[10] + __aTemp[09])
 __XGenStr[1] := (__XGenStr[1] + __aTemp[08] + __aTemp[07] + __aTemp[06] + __aTemp[05] + __aTemp[04] + __aTemp[03] + __aTemp[02] + __aTemp[01])
 __nLenGen := Len(__XGenStr[1])

If (__nSetCmd > 0)
For __nB00 = 1 To __nSetCmd Step 1
If (Empty(__aCmd[__nB00]) <> .T.)
 ExecuteCmd(__aCmd[__nB00])
EndIf
Next __nB00
EndIf

Next __aBucle[001]
Next __aBucle[002]
Next __aBucle[003]
Next __aBucle[004]
Next __aBucle[005]
Next __aBucle[006]
Next __aBucle[007]
Next __aBucle[008]
Next __aBucle[009]
Next __aBucle[010]
Next __aBucle[011]
Next __aBucle[012]
Next __aBucle[013]
Next __aBucle[014]
Next __aBucle[015]
Next __aBucle[016]
Next __aBucle[017]
Next __aBucle[018]
Next __aBucle[019]
Next __aBucle[020]
Next __aBucle[021]
Next __aBucle[022]
Next __aBucle[023]
Next __aBucle[024]
Next __aBucle[025]
Next __aBucle[026]
Next __aBucle[027]
Next __aBucle[028]
Next __aBucle[029]
Next __aBucle[030]
Next __aBucle[031]
Next __aBucle[032]
Next __aBucle[033]
Next __aBucle[034]
Next __aBucle[035]
Next __aBucle[036]
Next __aBucle[037]
Next __aBucle[038]
Next __aBucle[039]
Next __aBucle[040]
Next __aBucle[041]
Next __aBucle[042]
Next __aBucle[043]
Next __aBucle[044]
Next __aBucle[045]
Next __aBucle[046]
Next __aBucle[047]
Next __aBucle[048]
Next __aBucle[049]
Next __aBucle[050]
Next __aBucle[051]
Next __aBucle[052]
Next __aBucle[053]
Next __aBucle[054]
Next __aBucle[055]
Next __aBucle[056]
Next __aBucle[057]
Next __aBucle[058]
Next __aBucle[059]
Next __aBucle[060]
Next __aBucle[061]
Next __aBucle[062]
Next __aBucle[063]
Next __aBucle[064]
Next __aBucle[065]
Next __aBucle[066]
Next __aBucle[067]
Next __aBucle[068]
Next __aBucle[069]
Next __aBucle[070]
Next __aBucle[071]
Next __aBucle[072]
Next __aBucle[073]
Next __aBucle[074]
Next __aBucle[075]
Next __aBucle[076]
Next __aBucle[077]
Next __aBucle[078]
Next __aBucle[079]
Next __aBucle[080]
Next __aBucle[081]
Next __aBucle[082]
Next __aBucle[083]
Next __aBucle[084]
Next __aBucle[085]
Next __aBucle[086]
Next __aBucle[087]
Next __aBucle[088]
Next __aBucle[089]
Next __aBucle[090]
Next __aBucle[091]
Next __aBucle[092]
Next __aBucle[093]
Next __aBucle[094]
Next __aBucle[095]
Next __aBucle[096]
Next __aBucle[097]
Next __aBucle[098]
Next __aBucle[099]
Next __aBucle[100]
Next __aBucle[101]
Next __aBucle[102]
Next __aBucle[103]
Next __aBucle[104]
Next __aBucle[105]
Next __aBucle[106]
Next __aBucle[107]
Next __aBucle[108]
Next __aBucle[109]
Next __aBucle[110]
Next __aBucle[111]
Next __aBucle[112]
Next __aBucle[113]
Next __aBucle[114]
Next __aBucle[115]
Next __aBucle[116]
Next __aBucle[117]
Next __aBucle[118]
Next __aBucle[119]
Next __aBucle[120]
Next __aBucle[121]
Next __aBucle[122]
Next __aBucle[123]
Next __aBucle[124]
Next __aBucle[125]
Next __aBucle[126]
Next __aBucle[127]
Next __aBucle[128]
Next __aBucle[129]
Next __aBucle[130]
Next __aBucle[131]
Next __aBucle[132]
Next __aBucle[133]
Next __aBucle[134]
Next __aBucle[135]
Next __aBucle[136]
Next __aBucle[137]
Next __aBucle[138]
Next __aBucle[139]
Next __aBucle[140]
Next __aBucle[141]
Next __aBucle[142]
Next __aBucle[143]
Next __aBucle[144]
Next __aBucle[145]
Next __aBucle[146]
Next __aBucle[147]
Next __aBucle[148]
Next __aBucle[149]
Next __aBucle[150]
Next __aBucle[151]
Next __aBucle[152]
Next __aBucle[153]
Next __aBucle[154]
Next __aBucle[155]
Next __aBucle[156]
Next __aBucle[157]
Next __aBucle[158]
Next __aBucle[159]
Next __aBucle[160]
Next __aBucle[161]
Next __aBucle[162]
Next __aBucle[163]
Next __aBucle[164]
Next __aBucle[165]
Next __aBucle[166]
Next __aBucle[167]
Next __aBucle[168]
Next __aBucle[169]
Next __aBucle[170]
Next __aBucle[171]
Next __aBucle[172]
Next __aBucle[173]
Next __aBucle[174]
Next __aBucle[175]
Next __aBucle[176]
Next __aBucle[177]
Next __aBucle[178]
Next __aBucle[179]
Next __aBucle[180]
Next __aBucle[181]
Next __aBucle[182]
Next __aBucle[183]
Next __aBucle[184]
Next __aBucle[185]
Next __aBucle[186]
Next __aBucle[187]
Next __aBucle[188]
Next __aBucle[189]
Next __aBucle[190]
Next __aBucle[191]
Next __aBucle[192]
Next __aBucle[193]
Next __aBucle[194]
Next __aBucle[195]
Next __aBucle[196]
Next __aBucle[197]
Next __aBucle[198]
Next __aBucle[199]
Next __aBucle[200]
Next __aBucle[201]
Next __aBucle[202]
Next __aBucle[203]
Next __aBucle[204]
Next __aBucle[205]
Next __aBucle[206]
Next __aBucle[207]
Next __aBucle[208]
Next __aBucle[209]
Next __aBucle[210]
Next __aBucle[211]
Next __aBucle[212]
Next __aBucle[213]
Next __aBucle[214]
Next __aBucle[215]
Next __aBucle[216]
Next __aBucle[217]
Next __aBucle[218]
Next __aBucle[219]
Next __aBucle[220]
Next __aBucle[221]
Next __aBucle[222]
Next __aBucle[223]
Next __aBucle[224]
Next __aBucle[225]
Next __aBucle[226]
Next __aBucle[227]
Next __aBucle[228]
Next __aBucle[229]
Next __aBucle[230]
Next __aBucle[231]
Next __aBucle[232]
Next __aBucle[233]
Next __aBucle[234]
Next __aBucle[235]
Next __aBucle[236]
Next __aBucle[237]
Next __aBucle[238]
Next __aBucle[239]
Next __aBucle[240]
Next __aBucle[241]
Next __aBucle[242]
Next __aBucle[243]
Next __aBucle[244]
Next __aBucle[245]
Next __aBucle[246]
Next __aBucle[247]
Next __aBucle[248]
Next __aBucle[249]
Next __aBucle[250]
Next __aBucle[251]
Next __aBucle[252]
Next __aBucle[253]
Next __aBucle[254]
Next __aBucle[255]
Next __aBucle[256]

 Return (.T.)

*()> {String}
Function XRAt(__cStr, __cSch, __nExt)
* XRAt() - Bsqueda de Caracteres desde el final en datos de tipo String.
* Desarrollo de la Funcin:  23-Oct-2004 > 13-Sep-2005
* (c) Alejandro Padrino, 2.004 - 2.005
*
* Funciones Relacionadas:
* - XSchCnv()
*
* __cStr - Cadena de Caracteres.
* __cSch - Caracteres a buscar.
* __nExt - Buscar ignorando maysculas, minsculas, acentos y smbolos.
*

 __cStr := IIf((__nExt > 0), XSchCnv(__cStr, __nExt), __cStr)
 Return (RAt(Lower(__cSch), Lower(__cStr)))

*()> {String}
Function XSchCnv(__cStr, __nExt)
* XSchCnv() - Conversin de Caracteres para bsquedas extendidas.
* Desarrollo de la Funcin:  13-Sep-2005 > 13-Sep-2005
* (c) Alejandro Padrino, 2.005
*
* Funciones Relacionadas:
* - XAt()
* - XRAt()
*
* __cStr   - Cadena de Caracteres.
* __nExt   - Conversin de los Caracteres de Windows.
*
* __nASCII - Variable Temporal #00.
* __nB00   - Variable Temporal #01.
*
* Caracter: ASCII:  Chr_Win:
* ========= ======= ===============================
* A........ .65,97. 225,193,228,196,226,194,224,192
* E........ .69,101 233,201,235,203,234,202,232,200
* I........ .73,105 237,205,239,207,238,206,236,204
* O........ .79,111 243,211,246,214,244,212,242,210
* U........ .85,117 250,218,252,220,251,219,249,217
* C........ .67,99. 231,199........................
* ........ 164,165 165............................
* Y........ .89,121 255,253,221....................
*

 Local __XSchCnv := Space(0)
 Local __nASCII := 0
 Local __nB00 := 0

 __cStr := Lower(__cStr)

For __nB00 = 1 To Len(__cStr) Step 1
 __nASCII := Asc(SubStr(__cStr, __nB00, 1))
 __nASCII := IIf(((__nExt > 0) .And. ((__nASCII = 225) .Or. (__nASCII = 193) .Or. (__nASCII = 228) .Or. (__nASCII = 196) .Or. (__nASCII = 226) .Or. (__nASCII = 194) .Or. (__nASCII = 224) .Or. (__nASCII = 192))), 97, __nASCII)
 __nASCII := IIf(((__nExt > 0) .And. ((__nASCII = 233) .Or. (__nASCII = 201) .Or. (__nASCII = 235) .Or. (__nASCII = 203) .Or. (__nASCII = 234) .Or. (__nASCII = 202) .Or. (__nASCII = 232) .Or. (__nASCII = 200))), 101, __nASCII)
 __nASCII := IIf(((__nExt > 0) .And. ((__nASCII = 237) .Or. (__nASCII = 205) .Or. (__nASCII = 239) .Or. (__nASCII = 207) .Or. (__nASCII = 238) .Or. (__nASCII = 206) .Or. (__nASCII = 236) .Or. (__nASCII = 204))), 105, __nASCII)
 __nASCII := IIf(((__nExt > 0) .And. ((__nASCII = 243) .Or. (__nASCII = 211) .Or. (__nASCII = 246) .Or. (__nASCII = 214) .Or. (__nASCII = 244) .Or. (__nASCII = 212) .Or. (__nASCII = 242) .Or. (__nASCII = 210))), 111, __nASCII)
 __nASCII := IIf(((__nExt > 0) .And. ((__nASCII = 250) .Or. (__nASCII = 218) .Or. (__nASCII = 252) .Or. (__nASCII = 220) .Or. (__nASCII = 251) .Or. (__nASCII = 219) .Or. (__nASCII = 249) .Or. (__nASCII = 217))), 117, __nASCII)
 __nASCII := IIf(((__nExt > 0) .And. ((__nASCII = 231) .Or. (__nASCII = 199))), 99, __nASCII)
 __nASCII := IIf(((__nExt > 0) .And. (__nASCII = 165)), 164, __nASCII)
 __nASCII := IIf(((__nExt > 0) .And. ((__nASCII = 255) .Or. (__nASCII = 253) .Or. (__nASCII = 221))), 121, __nASCII)
 __XSchCnv := (__XSchCnv + Chr(__nASCII))
Next __nB00

 Return (__XSchCnv)

**********************************************************

*()> {Commands}
Function ExecuteCmd(__cStr)
* ExecuteCmd() - Ejecutor de Comandos xBase.
* Desarrollo de la Funcin:  14-Sep-2005 > 19-Mar-2006
* (c) Alejandro Padrino, 2.005 - 2.006
*
* Funciones Relacionadas:
* - GetParameters()
*
* __cStr       - Comando para ejecutar.
*
* __ExecuteCmd - Resultado de la funcin: <.T.> Indica que el ltimo comando
*                se ejecut correctamente.
*
* __SetCmd[]   - Array de parmetros.
*
*
*
*
*
*
*
*

 Local __ExecuteCmd := .F.
 Local __SetCmd := {}

 ErrorLevel(1000)
 __cStr := If((Left(LTrim(__cStr), 1) = Chr(44)), AllTrim(__cStr), (Chr(46) + AllTrim(__cStr)))
 __SetCmd := GetParameters(__cStr, 32)

Begin Sequence
Do Case
Case (Left(__cStr, 1) = Chr(42))
 __cStr := Space(0)

Case (Left(__cStr, 1) = Chr(44))
 ***()...Comm...

Case (Left(__cStr, 1) <> Chr(46))
 ***()...ShellCommand(_Fx00, If(_StatusLine[1] <> .F., 2, 1))...

Case (Left(__cStr, 1) = Chr(46))
Do Case
Case (XAt(__SetCmd[1], ".?", 0) > 0) .Or. (XAt(__SetCmd[1], ".Print", 0) > 0)
 ***() __ExecuteCmd :=  _C_RunPrint(__cStr, .F., 1)

Case (XAt(__SetCmd[1], ".Publ", 0) > 0)
 *** ... parameters to end.
 __ExecuteCmd := _C_Public(__SetCmd[2])











EndCase
EndCase
End Sequence


 Return (__ExecuteCmd)

*()> {Commands}
Function GetParameters(__cIn, __nASCII)
* GetParameters() - Obtiene los parmetros de un comando.
* Desarrollo de la Funcin:  19-Mar-2006 > 15-Sep-2006
* (c) Alejandro Padrino, 2.006
*
* Funciones Relacionadas:
* - ExecuteCmd()
*
* __cIn     - Comando para procesar.
* __nASCII  - Separador ASCII de los elementos del comando.
*
* __aTokens - Array de elementos devuelto por esta funcin.
* __nLevel  - Sub-Nivel de proceso de los elementos del comando.
* __cStr00  - Variable string temporal #00.
* __cStr01  - Variable string temporal #01.
* __nB00    - Variable numrica temporal #00.
* __lSw00   - Variable lgica temporal #00.
* __lSw01   - Variable lgica temporal #01.
* __lSw02   - Variable lgica temporal #02.
*

 Local __aTokens := {}
 Local __nLevel := 0
 Local __cStr00 := Space(0)
 Local __cStr01 := Space(0)
 Local __nB00 := 0
 Local __lSw00 := .F.
 Local __lSw01 := .F.
 Local __lSw02 := .F.

 __cIn := If(Empty(__cIn) <> .F., Chr(__nASCII), __cIn)

For __nB00 = 1 To Len(__cIn) Step 1
 __cStr01 := SubStr(__cIn, __nB00, 1)
 __lSw01 := If((__cStr01 <> Chr(__nASCII)), .T., __lSw01)

If (__lSw01 <> .F.)
 __lSw00 := If((__cStr01 <> Chr(34)), __lSw00, If((__lSw00 <> .T.) .And. (__lSw02 <> .T.), .T., .F.))
 __lSw02 := If((__cStr01 <> Chr(39)), __lSw02, If((__lSw02 <> .T.) .And. (__lSw00 <> .T.), .T., .F.))
 __nLevel := If((__cStr01 = Chr(123)) .And. (__lSw00 <> .T.) .And. (__lSw02 <> .T.), (__nLevel + 1), __nLevel)
 __nLevel := If((__cStr01 = Chr(125)) .And. (__lSw00 <> .T.) .And. (__lSw02 <> .T.), (__nLevel - 1), __nLevel)
 __nLevel := If((__cStr01 = Chr(91)) .And. (__lSw00 <> .T.) .And. (__lSw02 <> .T.), (__nLevel + 1), __nLevel)
 __nLevel := If((__cStr01 = Chr(93)) .And. (__lSw00 <> .T.) .And. (__lSw02 <> .T.), (__nLevel - 1), __nLevel)
 __nLevel := If((__cStr01 = Chr(40)) .And. ((__lSw00 <> .T.) .Or. (__lSw02 <> .T.)), (__nLevel + 1), __nLevel)
 __nLevel := If((__cStr01 = Chr(41)) .And. ((__lSw00 <> .T.) .Or. (__lSw02 <> .T.)), (__nLevel - 1), __nLevel)

If (__cStr01 = Chr(__nASCII)) .And. (__nLevel < 1) .And. (__lSw00 <> .T.) .And. (__lSw02 <> .T.)
 AAdd(__aTokens, __cStr00)
 __cStr00 := Space(0)
Else
 __cStr00 := (__cStr00 + __cStr01)
EndIf
EndIf
Next __nB00

 AAdd(__aTokens, __cStr00)
 AAdd(__aTokens, Space(0))
 Return (__aTokens)

*()> {Commands}
Function _C_Public(__cIn)
* _C_Public() - Comando Public.
* Desarrollo de la Funcin:  19-Mar-2006 > 19-Mar-2006
* (c) Alejandro Padrino, 2.006
*
* Funciones Relacionadas:
* - AddString()
* - ExecuteCmd()
* - GetParameters()
*
* __cIn     - Variable a declarar.
*
* __Public  - Resultado de la funcin.  Devuelve <.T.> si se ha podido
*             crear la variable o la matriz.
* __aTokens - Dimensiones de la matriz.
* __cStr00  - Nombre de la variable o matriz.
* __cStr01  - Dimensiones de la matriz a procesar.
* __cStr02  - Variable string temporal #00.
* __cStr03  - Variable string temporal #01.
* __nLevel  - Identificador de elementos de la matriz.
* __nPos    - Posicin de las dimensiones de la matriz.
* __lSw00   - Identificador de la matriz.
* __cMcr00  - Variable de macro temporal #00.
* __cMcr01  - Variable de macro temporal #01.
* __cMcr02  - Variable de macro temporal #02.
* __cMcr03  - Variable de macro temporal #03.
* __cMcr04  - Variable de macro temporal #04.
* __cMcr05  - Variable de macro temporal #05.
* __cMcr06  - Variable de macro temporal #06.
* __cMcr07  - Variable de macro temporal #07.
* __cMcr08  - Variable de macro temporal #08.
* __cMcr09  - Variable de macro temporal #09.
* __cMcr10  - Variable de macro temporal #10.
* __cMcr11  - Variable de macro temporal #11.
* __cMcr12  - Variable de macro temporal #12.
* __cMcr13  - Variable de macro temporal #13.
* __cMcr14  - Variable de macro temporal #14.
* __cMcr15  - Variable de macro temporal #15.
* __nB00    - Variable numrica temporal #00.
*
* Ayuda:
*
* Variables => Public _VarName
*              Public VarName
*
* Matrices  => Public _aMatriz[nDim1][nDim2][nDim3] ... [nDim16]
*              Public aMatriz[nDim1][nDim2][nDim3] ... [nDim16]
*
*              Aviso:  En D.O.S. no he podido declarar un array con ms de
*                      siete dimensiones.
*

 Local __Public := .F.
 Local __aTokens := {}
 Local __nPos := At(Chr(91), __cIn)
 Local __cStr00 := Space(0)
 Local __cStr01 := Space(0)
 Local __cStr02 := Space(0)
 Local __cStr03 := Space(0)
 Local __nLevel := 0
 Local __lSw00 := .F.
 Local __nB00 := 0

If (XAt(__cIn, Replicate(Chr(95), 2), 0) <> 1)
 __lSw00 := IIf((__nPos > 1), .T., .F.)
 __nPos := IIf((__nPos < 2), Len(__cIn), __nPos)
 __cStr00 := Left(__cIn, (__nPos - 1))
 __cStr01 := AllTrim(IIf((__lSw00 <> .F.), SubStr(__cIn, __nPos, Len(__cIn)), Space(0)))
 Release &__cStr00

If (__lSw00 <> .T.)
 Public &__cStr00
Else

For __nB00 = 1 To Len(__cStr01) Step 1
 __cStr02 := SubStr(__cStr01, __nB00, 1)

If (__cStr02 == Chr(91)) .And. (__nLevel < 1)
 __nLevel := (__nLevel + 1)
ElseIf (__cStr02 == Chr(93)) .And. (__nLevel = 1)
 AAdd(__aTokens, __cStr03)
 __cStr03 := Space(0)
 __nLevel := 0
Else
 __nLevel := IIf((__cStr02 == Chr(91)), (__nLevel + 1), __nLevel)
 __nLevel := IIf((__cStr02 == Chr(93)), (__nLevel - 1), __nLevel)
 __cStr03 := (__cStr03 + __cStr02)
EndIf
Next __nB00

 __nLevel := Len(__aTokens)

For __nB00 = 1 To __nLevel Step 1
 __cStr03 := ("__cMcr" + AddString(Str(__nB00 - 1), 2, (-1), 48))
 Private &__cStr03
 &__cStr03 := __aTokens[__nB00]
Next __nB00

Do Case
Case __nLevel == 1
 Public &__cStr00[&__cMcr00]

Case __nLevel == 2
 Public &__cStr00[&__cMcr00][&__cMcr01]

Case __nLevel == 3
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02]

Case __nLevel == 4
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03]

Case __nLevel == 5
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04]

Case __nLevel == 6
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05]

Case __nLevel == 7
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06]

Case __nLevel == 8
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07]

Case __nLevel == 9
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08]

Case __nLevel == 10
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08][&__cMcr09]

Case __nLevel == 11
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08][&__cMcr09][&__cMcr10]

Case __nLevel == 12
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08][&__cMcr09][&__cMcr10][&__cMcr11]

Case __nLevel == 13
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08][&__cMcr09][&__cMcr10][&__cMcr11][&__cMcr12]

Case __nLevel == 14
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08][&__cMcr09][&__cMcr10][&__cMcr11][&__cMcr12][&__cMcr13]

Case __nLevel == 15
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08][&__cMcr09][&__cMcr10][&__cMcr11][&__cMcr12][&__cMcr13][&__cMcr14]

Case __nLevel == 16
 Public &__cStr00[&__cMcr00][&__cMcr01][&__cMcr02][&__cMcr03][&__cMcr04][&__cMcr05][&__cMcr06][&__cMcr07][&__cMcr08][&__cMcr09][&__cMcr10][&__cMcr11][&__cMcr12][&__cMcr13][&__cMcr14][&__cMcr15]

EndCase
EndIf

 __Public := .T.
EndIf

 Return (__Public)

**********************************************************
